<?php
/*
 +-------------------------------------------------------------------------+
 | Nagios Plugin 0.1a for Cacti 0.8.6f                                     |
 | Copyright (C) 2005 Billy Gunn (billy@gunn.org)                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti and Nagios are the copyright of their respective owners.          |
 +-------------------------------------------------------------------------+
*/

chdir('../../');
include_once("./include/auth.php");
include_once("./include/config.php");

// Buffer page output because we need top modify headers
ob_start();

include_once("top_npc_header.php");

if (isset($_REQUEST["cmd"])) {
	$_POST["host"] = $_REQUEST["host"];
	$_POST["hostid"] = $_REQUEST["hostid"];
	if (isset($_REQUEST["service"])) {
		$_POST["service"] = ereg_replace("\+", " ", $_REQUEST["service"]);
	}
	if (isset($_REQUEST["serviceid"])) {
		$_POST["serviceid"] = $_REQUEST["serviceid"];
	}
	$_POST["command"] = $_REQUEST["cmd"];
}

switch ($_POST["command"]) {

        case 'PROCESS_SERVICE_CHECK_RESULT':
                process_svc_check_result();
                include_once("./include/bottom_footer.php");
                break;

        case 'SCHEDULE_SVC_CHECK':
                schedule_check();
                include_once("./include/bottom_footer.php");
                break;

        case 'SCHEDULE_HOST_CHECK':
                schedule_check();
                include_once("./include/bottom_footer.php");
                break;

        case 'SCHEDULE_HOST_SVC_CHECKS':
                schedule_check();
                include_once("./include/bottom_footer.php");
                break;

        case 'SCHEDULE_HOST_DOWNTIME':
                schedule_downtime();
                include_once("./include/bottom_footer.php");
                break;

        case 'PROCESS_HOST_CHECK_RESULT':
                process_host_check_result();
                include_once("./include/bottom_footer.php");
                break;

        case 'ACKNOWLEDGE_SVC_PROBLEM':
                comment();
                include_once("./include/bottom_footer.php");
                break;

        case 'ACKNOWLEDGE_HOST_PROBLEM':
                comment();
                include_once("./include/bottom_footer.php");
                break;

        case 'ADD_SVC_COMMENT':
                comment();
                include_once("./include/bottom_footer.php");
                break;

        case 'ADD_HOST_COMMENT':
                comment();
                include_once("./include/bottom_footer.php");
                break;

        case 'DISABLE_HOST_SVC_CHECKS':
                host_svc_checks();
                include_once("./include/bottom_footer.php");
                break;

        case 'ENABLE_HOST_SVC_CHECKS':
                host_svc_checks();
                include_once("./include/bottom_footer.php");
                break;

        case 'NULL':
                error();
                include_once("./include/bottom_footer.php");
                break;

        default:
                genericCommand();
                include_once("./include/bottom_footer.php");
                break;
}


function error() {

	echo "<br><br><h2><center>Please choose a valid command.</center></h2>";			

	// Redirect back to refering page 5 seconds
	header("Refresh: 5; URL=" . $_SERVER["HTTP_REFERER"]);
	ob_end_flush();
}


function cmdStatus($status) {

	if (!$status) {
		echo "<br><br><h2><center>Your command request was successfully submitted to Nagios for processing.</center></h2>";
		echo "<br><h3><center>Note: It may take a while before the command is actually processed.</center></h3>";
	} else {
		echo "<br><br><h2><center>There was a problem submitting your command to Nagios for processing.</center></h2>";
	}

	// Redirect back to extinfo.php 5 seconds
	header("Refresh: 5; URL=" . $_POST["referer"]);
	ob_end_flush();

}


function genericCommand() {

/*

This function will process commands in the format of:

[unix time] COMMAND;<host_name>;<service_description>

*/

	if (isset($_POST["command"])) {



		$file = read_config_option("path_nagios_cmd");
		$status = 0;

		// Build the command and send it to Nagios
		if ($_POST["command"] != "DEL_SVC_COMMENT" && isset($_POST["service"])) {
			// Generic service command
			$status = exec('echo [`date +%s`] ' . $_POST["command"] . '\;' . $_POST["host"] . '\;' . $_POST["service"] . ' >> ' . $file);
		} else {
			// Generic host command
			$status = exec('echo [`date +%s`] ' . $_POST["command"] . '\;' . $_POST["host"] . ' >> ' . $file);
		}

		if (!$status) {
			if ($_POST["command"] == "REMOVE_SVC_ACKNOWLEDGEMENT") {
				db_execute("delete from npc_comment where serviceid = " . $_POST["serviceid"] . " and type = 4;");
				// Delete the comment associated with the acknowledgment from Nagios
				exec('echo [`date +%s`] DEL_ALL_SVC_COMMENTS\;' . $_POST["host"] . '\;' . $_POST["service"] . ' >> ' . $file);
			}
			if ($_POST["command"] == "DEL_ALL_SVC_COMMENTS") {
				db_execute("delete from npc_comment where serviceid = " . $_POST["serviceid"] . " and type != 4;");
			}
			if ($_POST["command"] == "DEL_SVC_COMMENT") {
				db_execute("delete from npc_comment where id = " . $_REQUEST["id"] . " and serviceid = " . $_POST["serviceid"] . ";");
			}
		}

		cmdStatus($status);
	}

}


function comment() {

// [unix time] ACKNOWLEDGE_SVC_PROBLEM;<host_name>;<service>;<sticky>;<send_notification>;<persist>;<Author>;<comment>
// For the sticky option 2 = true, and 1 = false.

	$file = read_config_option("path_nagios_cmd");

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";
	$status = 0;

	switch($_POST["command"]) {
		case "ACKNOWLEDGE_SVC_PROBLEM":
			$title = "Acknowledge Service Problem";
                        break;
		case "ACKNOWLEDGE_HOST_PROBLEM":
			$title = "Acknowledge Host Problem";
                        break;
		case "ADD_SVC_COMMENT":
			$title = "Add Service Comment";
                        break;
		case "ADD_HOST_COMMENT":
			$title = "Add Host Comment";
                        break;
	}

    	if (isset($_POST["author"]) && isset($_POST["comment"])) {

		if ($_POST["command"] == "ACKNOWLEDGE_SVC_PROBLEM" || $_POST["command"] == "ACKNOWLEDGE_HOST_PROBLEM") {
			if (isset($_POST["sticky"])) {
				$sticky = 2;
			} else {
				$sticky = 1;
			}
			if (isset($_POST["notify"])) {
				$notify = 1;
			} else {
				$notify = 0;
			}
		}
		if (isset($_POST["persist"])) {
			$persist = 1;
		} else {
			$persist = 0;
		}

		// Build the command and send it to Nagios
		if ($_POST["command"] == "ACKNOWLEDGE_SVC_PROBLEM") {
			$status = exec('echo [`date +%s`] ' . $_POST["command"] . '\;' . $_POST["host"] . '\;' . $_POST["service"] . '\;' . $sticky . '\;' . $notify . '\;' . $persist . '\;' . $_POST["author"] . '\;' . $_POST["comment"] . ' >> ' . $file);
		} elseif ($_POST["command"] == "ACKNOWLEDGE_HOST_PROBLEM") {
			$status = exec('echo [`date +%s`] ' . $_POST["command"] . '\;' . $_POST["host"] . '\;' . $sticky . '\;' . $notify . '\;' . $persist . '\;' . $_POST["author"] . '\;' . $_POST["comment"] . ' >> ' . $file);
		}

		if (!$status) {

			/* 
			   I need to get my C skills sharpened up so I can modify the inserter module to 
			   handle comments. Until then I will only handle comments in NPC since comments 
			   don't affect Nagios logic. Acknowledgments do affect logic though and when an 
			   acknowledgment is added in Nagios a comment is added also. 

			   The problem is that when an Acknowledgment is removed in Nagios the comment
			   associated with it is not removed and has to be removed seperatley via its 
			   comment ID. Until I fix the event broker I don't know what the comment ID
			   is.

			   The workaround for now is to only add coments to the NPC database and not to 
			   Nagios directly. Those comments can then be removed. When submitting an 
			   Acknowledgment, a comment has to be submitted with it. That comment will be
			   be deleted from NPC when the associated acknowledgment is deleted. On the 
			   Nagios side a delete all comments command will be sent with the remove
			   acknowledgment command.
			*/

			if ($_POST["command"] == "ACKNOWLEDGE_SVC_PROBLEM") {
				db_execute("insert into npc_comment (serviceid, author, comment, persist, type) values (" . $_POST["serviceid"] . ",'" . $_POST["author"] . "','" . $_POST["comment"] . "'," . $persist . ",4);");
			} elseif ($_POST["command"] == "ADD_SVC_COMMENT") {
				db_execute("insert into npc_comment (serviceid, author, comment, persist, type) values (" . $_POST["serviceid"] . ",'" . $_POST["author"] . "','" . $_POST["comment"] . "'," . $persist . ",2);");
			} elseif ($_POST["command"] == "ACKNOWLEDGE_HOST_PROBLEM") {
				db_execute("insert into npc_comment (hostid, author, comment, persist, type) values (" . $_POST["hostid"] . ",'" . $_POST["author"] . "','" . $_POST["comment"] . "'," . $persist . ",3);");
			} elseif ($_POST["command"] == "ADD_HOST_COMMENT") {
				db_execute("insert into npc_comment (hostid, author, comment, persist, type) values (" . $_POST["hostid"] . ",'" . $_POST["author"] . "','" . $_POST["comment"] . "'," . $persist . ",1);");
			}
				
		}

		cmdStatus($status);

	} elseif (isset($_POST["referer"])) {
		echo "<br><br><h2><center>Author and Comment are required fields.</center></h2>";
		ob_end_flush();
    	}

	if (!isset($_POST["referer"])) {
?>
   <table width="40%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong><?php echo $title; ?></strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
		<FORM NAME="gm" ACTION="" method="post">
		   <INPUT TYPE='hidden' NAME='referer' VALUE='<?php echo $_SERVER["HTTP_REFERER"]; ?>'>
		   <INPUT TYPE='hidden' NAME='host' VALUE='<?php echo $_POST["host"]; ?>'>
		   <INPUT TYPE='hidden' NAME='hostid' VALUE='<?php echo $_POST["hostid"]; ?>'>
		   <INPUT TYPE='hidden' NAME='service' VALUE='<?php echo $_POST["service"]; ?>'>
		   <INPUT TYPE='hidden' NAME='serviceid' VALUE='<?php echo $_POST["serviceid"]; ?>'>
		   <INPUT TYPE='hidden' NAME='command' VALUE='<?php echo $_POST["command"]; ?>'>

		   <?php if ($_POST["command"] == "ACKNOWLEDGE_SVC_PROBLEM" || $_POST["command"] == "ACKNOWLEDGE_HOST_PROBLEM") { ?>
                   <tr bgcolor='<?php echo $background1; ?>'>
                        <td nowrap>Sticky Acknowledgement:</td>
                        <td><input type='checkbox' name='sticky' checked></td>
		   </tr>
		   <tr bgcolor='<?php echo $background2; ?>'>
                        <td>Send Notification:</td>
                        <td><input type='checkbox' name='notify' checked></td>
		   </tr>
		   <?php }  ?>

		   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>Persistent Comment:</td>
                        <td><input type='checkbox' name='persist' checked></td>
		   </tr>
		   <tr bgcolor='<?php echo $background2; ?>'>
                        <td>*Author:</td>
                        <td><input type='text' name='author' value='<?php print db_fetch_cell("select username from user_auth where id=" . $_SESSION["sess_user_id"]);?>'></td>
		   </tr>
		   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>*Comment:</td>
                        <td><input type='text' size='60' name='comment' checked></td>
		   </tr>
		   <tr bgcolor='<?php echo $background2; ?>'>
                        <td>Description:</td>
                        <td>This command is used to add a comment for the specified service. If you work with other administrators, you may find it useful to share information about a host or service that is having problems if more than one of you may be working on it. If you do not check the 'persistent' option, the comment will automatically be deleted the next time Nagios is restarted.</td>
		   </tr>
	    </table>
	</td>
	</tr>
	<tr>
	   <td colspan=2>
    		<table align='center' width='40%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>
        		<tr>
             			<td bgcolor="#f5f5f5" align="right">
                      			<a href='<?php echo $_SERVER["HTTP_REFERER"]; ?>'><input type='submit' align='absmiddle' VALUE='Cancel'></a>
                      			<input type='submit' align='absmiddle' VALUE='submit'>
             			</td>
        		</tr>
    		</table>
    	</tr>
        </FORM>
    </table>
		
<?php
	}

}


function process_svc_check_result() {

// [unix time] PROCESS_SERVICE_CHECK_RESULT;<host_name>;<service_description>;<return_code>;<plugin_output>|performance_data

	$file = read_config_option("path_nagios_cmd");

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";

    if (isset($_POST["plugin_state"])) {
	if (isset($_POST["plugin_output"])) {

		// Build the command and send it to Nagios
		$status = exec('echo [`date +%s`] PROCESS_SERVICE_CHECK_RESULT\;' . $_POST["host"] . '\;' . $_POST["service"] . '\;' . $_POST["plugin_state"] . '\;' . $_POST["plugin_output"] . '\|' . $_POST["performance_data"] . ' >> ' . $file);

		cmdStatus($status);

	} else {
		echo "<br><br><h2><center>Check Output: is a required field.</center></h2>";
		ob_end_flush();
	}
    }

	if (!isset($_POST["referer"])) {

?>
   <table width="40%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong>Command Options</strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
		<FORM NAME="gm" ACTION="" method="post">
		   <INPUT TYPE='hidden' NAME='command' VALUE='PROCESS_SERVICE_CHECK_RESULT'>
		   <INPUT TYPE='hidden' NAME='referer' VALUE='<?php echo $_SERVER["HTTP_REFERER"]; ?>'>
		   <INPUT TYPE='hidden' NAME='host' VALUE='<?php echo $_POST["host"]; ?>'>
		   <INPUT TYPE='hidden' NAME='service' VALUE='<?php echo $_POST["service"]; ?>'>
                   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>*Check Result:</td>
                        <td>
                           <select name="plugin_state" size="1">
                                <option value='0'>OK</option>
                                <option value='1'>WARNING</option>
                                <option value='3'>UNKNOWN</option>
                                <option value='2'>CRITICAL</option>
                           </select>
                        </td>
		   </tr>
		   <tr bgcolor='<?php echo $background2; ?>'>
			<td>*Check Output:</td>
			<td><input type='text' name='plugin_output' value=''></td>
		   </tr>
		   <tr bgcolor='<?php echo $background1; ?>'>
			<td>Performance Data:</td>
			<td><input type='text' name='performance_data' value=''></td>
		   </tr>
                        <td><INPUT TYPE="submit" VALUE="Submit"></td>
      </tr>
            </FORM>
   </table>
	</td>
	</tr>
    </table>
		
<?php

	}


}


function process_host_check_result() {

// [unix time] PROCESS_HOST_CHECK_RESULT;<host_name>;<return_code>;<plugin_output>|performance_data

	$file = read_config_option("path_nagios_cmd");

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";

    if (isset($_POST["plugin_state"])) {
	if (isset($_POST["plugin_output"])) {

		// Build the command and send it to Nagios
		$status = exec('echo [`date +%s`] PROCESS_HOST_CHECK_RESULT\;' . $_POST["host"] . '\;' . $_POST["plugin_state"] . '\;' . $_POST["plugin_output"] . '\|' . $_POST["performance_data"] . ' >> ' . $file);

		cmdStatus($status);

	} else {
		echo "<br><br><h2><center>Check Output: is a required field.</center></h2>";
		ob_end_flush();
	}
    }

	if (!isset($_POST["referer"])) {

?>
   <table width="40%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong>Command Options</strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
		<FORM NAME="gm" ACTION="" method="post">
		   <INPUT TYPE='hidden' NAME='command' VALUE='PROCESS_HOST_CHECK_RESULT'>
		   <INPUT TYPE='hidden' NAME='referer' VALUE='<?php echo $_SERVER["HTTP_REFERER"]; ?>'>
		   <INPUT TYPE='hidden' NAME='host' VALUE='<?php echo $_POST["host"]; ?>'>
                   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>*Check Result:</td>
                        <td>
                           <select name="plugin_state" size="1">
                                <option value='0'>UP</option>
                                <option value='1'>DOWN</option>
                                <option value='2'>UNREACHABLE</option>
                           </select>
                        </td>
		   </tr>
		   <tr bgcolor='<?php echo $background2; ?>'>
			<td>*Check Output:</td>
			<td><input type='text' name='plugin_output' value=''></td>
		   </tr>
		   <tr bgcolor='<?php echo $background1; ?>'>
			<td>Performance Data:</td>
			<td><input type='text' name='performance_data' value=''></td>
		   </tr>
      </tr>
   </table>
	</td>
	</tr>
    </table>
    <table align='center' width='40%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>
        <tr>
             <td bgcolor="#f5f5f5" align="right">
                      <!-- <a href='<?php echo $_SERVER["HTTP_REFERER"]; ?>'><img src='../../images/button_cancel2.gif' alt='Cancel' align='absmiddle' border='0'></a> -->
                      <a href='<?php echo $_SERVER["HTTP_REFERER"]; ?>'><input type='submit' align='absmiddle' VALUE='Cancel'></a>
                      <input type='submit' align='absmiddle' VALUE='submit'>
             </td>
        </tr>
        </FORM>
   </table>
		
<?php

	}


}

function host_svc_checks() {

// [unix time] DISABLE_HOST_SVC_CHECKS;<host>
// [unix time] DISABLE_HOST_CHECK;<host>

	$file = read_config_option("path_nagios_cmd");

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";
	$status = 0;

	switch($_POST["command"]) {
		case "DISABLE_HOST_SVC_CHECKS":
			$title = "Disable active checks of all services on " . $_POST["service"];
                        break;
		case "ENABLE_HOST_SVC_CHECKS":
			$title = "Schedule a check of " . $_POST["host"];
                        break;
	}

	if (isset($_POST["submit"])) {

		// Convert the check time to epoch
		$unixTime = strtotime($_POST["time"]);


		// Build the command and send it to Nagios
		if ($_POST["command"] == "SCHEDULE_SVC_CHECK") {
			if ($_POST["force"]) {
				$status = exec('echo [`date +%s`] SCHEDULE_FORCED_SVC_CHECK\;' . $_POST["host"] . '\;' . $_POST["service"] . '\;' . $unixTime . ' >> ' . $file);
			} else {
				$status = exec('echo [`date +%s`] SCHEDULE_SVC_CHECK\;' . $_POST["host"] . '\;' . $_POST["service"] . '\;' . $unixTime . ' >> ' . $file);
			}
		}

		if ($_POST["command"] == "SCHEDULE_HOST_CHECK") {
			if ($_POST["force"]) {
				$status = exec('echo [`date +%s`] SCHEDULE_FORCED_HOST_CHECK\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			} else {
				$status = exec('echo [`date +%s`] SCHEDULE_HOST_CHECK\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			}
		}
					 
		if ($_POST["command"] == "SCHEDULE_HOST_SVC_CHECKS") {
			if ($_POST["force"]) {
				$status = exec('echo [`date +%s`] SCHEDULE_FORCED_HOST_SVC_CHECKS\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			} else {
				$status = exec('echo [`date +%s`] SCHEDULE_HOST_SVC_CHECKS\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			}
		}

		cmdStatus($status);


	}

        if (!isset($_POST["referer"])) {
?>
   <table width="40%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong><?php echo $title; ?></strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
		<FORM NAME="gm" ACTION="" method="post">
		   <INPUT TYPE='hidden' NAME='referer' VALUE='<?php echo $_SERVER["HTTP_REFERER"]; ?>'>
		   <INPUT TYPE='hidden' NAME='host' VALUE='<?php echo $_POST["host"]; ?>'>
		   <INPUT TYPE='hidden' NAME='hostid' VALUE='<?php echo $_POST["hostid"]; ?>'>
		   <INPUT TYPE='hidden' NAME='service' VALUE='<?php echo $_POST["service"]; ?>'>
		   <INPUT TYPE='hidden' NAME='serviceid' VALUE='<?php echo $_POST["serviceid"]; ?>'>
		   <INPUT TYPE='hidden' NAME='command' VALUE='<?php echo $_POST["command"]; ?>'>

                   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>Host:</td>
                        <td><?php echo $_POST["host"]; ?></td>
		   </tr>
		   <tr bgcolor='<?php echo $background2; ?>'>
                        <td nowrap>Disable For Host Too:</td>
                        <td><input type='checkbox' name='disableHost' checked></td>
		   </tr>
		   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>Description:</td>
			<?php if ($_POST["command"] == "DISABLE_HOST_SVC_CHECKS") { ?>
                        		<td></td>
			<?php } elseif ($_POST["command"] == "ENABLE_HOST_SVC_CHECKS") { ?>
                        		<td>This command is used to schedule the next check of [ <?php echo $_POST["service"]; ?> ]. Nagios will re-queue [ <?php echo $_POST["service"]; ?> ] to be checked at the time you specify. If you select the force check option, Nagios will force a check of [ <?php echo $_POST["service"]; ?> ] regardless of both what time the scheduled check occurs and whether or not checks are enabled for the service.</td>
			<?php } ?>
		   </tr>
	    </table>
	</td>
	</tr>
    </table>
    <table align='center' width='40%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>
        <tr>
             <td bgcolor="#f5f5f5" align="right">
                      <a href='<?php echo $_SERVER["HTTP_REFERER"]; ?>'><input type='submit' align='absmiddle' VALUE='Cancel'></a>
                      <input type='submit' align='absmiddle' name='submit' VALUE='submit'>
             </td>
        </tr>
        </FORM>
   </table>
		
<?php
	}

}

function schedule_check() {

// [unix time] SCHEDULE_HOST_CHECK;<host_name>;<unix time>
// [unix time] SCHEDULE_FORCED_HOST_CHECK;<host_name>;<unix time>

// [unix time] SCHEDULE_SVC_CHECK;<host_name>;<service>;<unix time>
// [unix time] SCHEDULE_FORCED_SVC_CHECK;<host_name>;<service>;<unix time>

// [unix time] SCHEDULE_HOST_SVC_CHECKS;<host_name>;<unix time>
// [unix time] SCHEDULE_FORCED_HOST_SVC_CHECKS;<host_name>;<unix time>

	$file = read_config_option("path_nagios_cmd");

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";
	$status = 0;

	switch($_POST["command"]) {
		case "SCHEDULE_SVC_CHECK":
			$title = "Schedule a check of " . $_POST["service"];
                        break;
		case "SCHEDULE_HOST_CHECK":
			$title = "Schedule a check of " . $_POST["host"];
                        break;
		case "SCHEDULE_HOST_SVC_CHECKS":
			$title = "Schedule a check of all services on " . $_POST["host"];
                        break;
	}

	if (isset($_POST["submit"])) {

		// Convert the check time to epoch
		$unixTime = strtotime($_POST["time"]);


		// Build the command and send it to Nagios
		if ($_POST["command"] == "SCHEDULE_SVC_CHECK") {
			if ($_POST["force"]) {
				$status = exec('echo [`date +%s`] SCHEDULE_FORCED_SVC_CHECK\;' . $_POST["host"] . '\;' . $_POST["service"] . '\;' . $unixTime . ' >> ' . $file);
			} else {
				$status = exec('echo [`date +%s`] SCHEDULE_SVC_CHECK\;' . $_POST["host"] . '\;' . $_POST["service"] . '\;' . $unixTime . ' >> ' . $file);
			}
		}

		if ($_POST["command"] == "SCHEDULE_HOST_CHECK") {
			if ($_POST["force"]) {
				$status = exec('echo [`date +%s`] SCHEDULE_FORCED_HOST_CHECK\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			} else {
				$status = exec('echo [`date +%s`] SCHEDULE_HOST_CHECK\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			}
		}
					 
		if ($_POST["command"] == "SCHEDULE_HOST_SVC_CHECKS") {
			if ($_POST["force"]) {
				$status = exec('echo [`date +%s`] SCHEDULE_FORCED_HOST_SVC_CHECKS\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			} else {
				$status = exec('echo [`date +%s`] SCHEDULE_HOST_SVC_CHECKS\;' . $_POST["host"] . '\;' . $unixTime . ' >> ' . $file);
			}
		}

		cmdStatus($status);


	}

        if (!isset($_POST["referer"])) {
?>
   <table width="40%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong><?php echo $title; ?></strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
		<FORM NAME="gm" ACTION="" method="post">
		   <INPUT TYPE='hidden' NAME='referer' VALUE='<?php echo $_SERVER["HTTP_REFERER"]; ?>'>
		   <INPUT TYPE='hidden' NAME='host' VALUE='<?php echo $_POST["host"]; ?>'>
		   <INPUT TYPE='hidden' NAME='hostid' VALUE='<?php echo $_POST["hostid"]; ?>'>
		   <INPUT TYPE='hidden' NAME='service' VALUE='<?php echo $_POST["service"]; ?>'>
		   <INPUT TYPE='hidden' NAME='serviceid' VALUE='<?php echo $_POST["serviceid"]; ?>'>
		   <INPUT TYPE='hidden' NAME='command' VALUE='<?php echo $_POST["command"]; ?>'>

                   <tr bgcolor='<?php echo $background1; ?>'>
                        <td>Host:</td>
                        <td><?php echo $_POST["host"]; ?></td>
		   </tr>
		   <?php if ($_POST["command"] == "SCHEDULE_SVC_CHECK") { ?>
		   <tr bgcolor='<?php echo $background2; ?>'>
                        <td>Service:</td>
                        <td><?php echo $_POST["service"]; ?></td>
		   </tr>
		   <?php } ?>
		   <tr bgcolor='<?php if ($_POST["command"] == "SCHEDULE_SVC_CHECK") { echo $background1; } else { echo $background2; } ?>'>
                        <td width="20%" nowrap>*Check Time:</td>
                        <td><input type='text' name='time' value='<?php print date("m/d/y H:i:s"); ?>'</td>
		   </tr>
		   <tr bgcolor='<?php if ($_POST["command"] == "SCHEDULE_SVC_CHECK") { echo $background2; } else { echo $background1; } ?>'>
                        <td nowrap>Force Check:</td>
                        <td><input type='checkbox' name='force' checked></td>
		   </tr>
		   <tr bgcolor='<?php if ($_POST["command"] == "SCHEDULE_SVC_CHECK") { echo $background1; } else { echo $background2; } ?>'>
                        <td>Description:</td>
			<?php if ($_POST["command"] == "SCHEDULE_HOST_CHECK") { ?>
                        		<td>This command is used to schedule the next check of <?php echo $_POST["host"]; ?>. Nagios will re-queue <?php echo $_POST["host"]; ?> to be checked at the time you specify. If you select the force check option, Nagios will force a check of <?php echo $_POST["host"]; ?> regardless of both what time the scheduled check occurs and whether or not checks are enabled for the host.</td>
			<?php } elseif ($_POST["command"] == "SCHEDULE_SVC_CHECK") { ?>
                        		<td>This command is used to schedule the next check of [ <?php echo $_POST["service"]; ?> ]. Nagios will re-queue [ <?php echo $_POST["service"]; ?> ] to be checked at the time you specify. If you select the force check option, Nagios will force a check of [ <?php echo $_POST["service"]; ?> ] regardless of both what time the scheduled check occurs and whether or not checks are enabled for the service.</td>
			<?php } elseif ($_POST["command"] == "SCHEDULE_HOST_SVC_CHECKS") { ?>
                        		<td>This command is used to scheduled the next check of all services on <?php echo $_POST["host"]; ?>. If you select the force check option, Nagios will force a check of all services on <?php echo $_POST["host"]; ?> regardless of both what time the scheduled checks occur and whether or not checks are enabled for those services.</td>
			<?php } ?>
		   </tr>
	    </table>
	</td>
	</tr>
    </table>
    <table align='center' width='40%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>
        <tr>
             <td bgcolor="#f5f5f5" align="right">
                      <a href='<?php echo $_SERVER["HTTP_REFERER"]; ?>'><input type='submit' align='absmiddle' VALUE='Cancel'></a>
                      <input type='submit' align='absmiddle' name='submit' VALUE='submit'>
             </td>
        </tr>
        </FORM>
   </table>
		
<?php
	}

}


function schedule_downtime() {

}


?>
