<?php
/*
 +-------------------------------------------------------------------------+
 | Nagios Plugin 0.1a for cacti 0.8.6f                                     |
 | Copyright (C) 2005 Billy Gunn (billy@gunn.org)                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti and Nagios are the copyright of their respective owners.          |
 |									   |
 | Code used throughout this program was borrowed from various places:     |
 |	- Cacti								   |
 |	- Nagios							   |
 |	- Nagios-db							   |
 |	- Cacti Plugin Architecture					   |
 +-------------------------------------------------------------------------+
*/

chdir('../../');
include_once("./include/auth.php");
include_once("./include/config.php");

// Refresh the page at a user supplied interval
header("Refresh: " . read_config_option("npc_refresh") . "; URL=" . $_SERVER["REQUEST_URI"]);
include("top_npc_header.php");



function formatTime($time) {

        $days = floor($time/60/60/24);
        $time -= $days*60*60*24;
        $hours = floor($time/60/60);
        $time -= $hours*60*60;
        $minutes = floor($time/60);
        $time -= $minutes*60;
        $seconds = $time;

        return ($days . "d " . $hours . "h " . $minutes . "m " . $seconds . "s");
}


if (!isset($_REQUEST["filter"])) { $_REQUEST["filter"] = ""; }
switch ($_REQUEST["filter"]) {
        case 'hostProblems':
                $whereClause = "and nhh.soft_state != 0 and nhh.soft_state != -1";
                break;

        default:
                $whereClause = "";
                break;
}


$host_config = db_fetch_assoc("select nh.id, nh.name, nh.active_checks_enabled, nh.passive_checks_enabled, nh.event_handler_enabled, nh.flap_detection_enabled, nh.notifications_enabled, nh.failure_prediction_enabled, nh.process_performance_data, nh.obsess_over_host, nh.event_handler, nh.cacti_graph_id, nhh.soft_state from npc_host as nh, npc_host_history as nhh where nh.configured = 1 and nhh.hostid = nh.id and nhh.lasted is NULL $whereClause");

$row_count = count($host_config);


?>

   <table width="98%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong>Host List</strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
            <thead>
               <tr class="textSubHeaderDark" bgcolor='#6d88ad'>
                  <td>Host</td>
                  <td>Status</td>
                  <td>Last Check</td>
                  <td>Duration</td>
                  <td>Plugin Output</td>
               </tr>
            </thead>

<?php

        $background1 = "#F5F5F5";
        $background2 = "#E7E9F2";
        $rowColor = $background1;


        for($i = 0; $i < $row_count; $i++) {

		/* Grab aditional data for each host. All this data could be gathered in one big query with some fancy left joining,
		   but that is out of my league at the moment and this works however inefficient */
		$host_flapping["flapping"] = db_fetch_cell("select id from npc_flapping_host where id = " . $host_config[$i]["id"]);
		$host_history = db_fetch_row("select started, soft_state, hard_state, current_attempt, plugin_output from npc_host_history where hostid = " . $host_config[$i]["id"] . " order by started desc;");
		$host_check = db_fetch_row("select check_command, check_execute_time, check_latency, from_unixtime(last_check) as last_check, from_unixtime(next_check) as next_check, max_attempts, last_notification, next_notification, no_more_notifications, check_type, performance_data from npc_host_check where hostid = " . $host_config[$i]["id"]);
		$comments = db_fetch_cell("select count(*) as count from npc_comment where hostid = " . $host_config[$i]["id"]);

		echo "<tr bgcolor='" . $rowColor . "'>";



		// Display the Host cell with any icons as needed
		echo "<td>";
                if ($host_config[$i]["cacti_graph_id"]) {
                        echo "<a onclick=\"toggleItem('hostGraph" . $i . "'); return false;\"><img src='images/graph.gif' alt='graph' border='0'></a> ";
                }
		echo "<a href='extinfo.php?type=1&hostid=" . $host_config[$i]["id"] . "&hostname=" . $host_config[$i]["name"] . "'>" . $host_config[$i]["name"] . "</a>";
		$host_ack = db_fetch_cell("select type from npc_comment where hostid = " . $host_config[$i]["id"] . " and type = 3;");
                if ($comments) {
                        echo "&nbsp <IMG SRC='images/comment.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='There are comments for this service' TITLE='This service has " . $comments["count"] . " comments'>";
                }
                if ($host_ack["type"]) {
                        echo "&nbsp; <IMG SRC='images/ack.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='This service problem has been acknowledged' TITLE='This service problem has been acknowledged'>";
                }
                if (!$host_config[$i]["active_checks_enabled"] && !$host_config[$i]["passive_checks_enabled"]) {
                        echo "&nbsp; <IMG SRC='images/disabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Active and passive checks have been disabled' TITLE='Active and passive checks have been disabled'>";
                } elseif (!$host_config[$i]["active_checks_enabled"]) {
                        echo "&nbsp <IMG SRC='images/passiveonly.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Active checks have been disabled - only passive checks are being accepted' TITLE='Active checks have been disabled - only passive checks are being accepted'>";
                }
		if ($host_config[$i]["notifications_enabled"] == "0") {
                	echo " <IMG SRC='images/ndisabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Notifications disabled' TITLE='Notifications disabled'>\n";
                }
		echo "</td>";

		

                // Display the cwstatus cell with color coding based on the host status
		echo "<td";
                switch($host_history["soft_state"])
                {
	                case "-1":
        		        echo " class='statusHOSTPENDING' nowrap>PENDING</td>";
                		break;
	                case "0":
        		        echo " class='statusHOSTUP' nowrap>UP</td>";
                		break;
	                case "1":
        		        echo " class='statusHOSTDOWN' nowrap>DOWN</td>";
                		break;
                	case "2":
                		echo " class='statusHOSTUNREACHABLE' nowrap>UNREACHABLE</td>";
                		break;
                }


		// Last Check cell
		echo "<td>" . $host_check["last_check"] . "</td>";


		// Duration cell
		$duration =  date("U") - $host_history["started"];
		echo "<td>" . formatTime($duration) . "</td>";


		// Plugin Output cell
		echo "<td>" . $host_history["plugin_output"] . "</td>";

		echo "</tr>";

		/* If a host has an associated graph, build a table to hold the graph */
                if ($host_config[$i]["cacti_graph_id"]) {
                        echo "<tr><td colspan='8'>";
                        echo "<center><table>";
                        echo "<tbody id='hostGraph" . $i . "' style='display:none';>";
                        echo "<tr><td>";
                        echo "<img src='../../graph_image.php?local_graph_id=" . $host_config[$i]["cacti_graph_id"] . "&rra_id=0'>";
                        echo "</td></tr>";
                        echo "</tbody>";
                        echo "</table></center>";
                        echo "</td></tr>";
                }


	}



   echo "</table>";
echo "</td>";
echo "</tr>";
echo "</table>";

include("./include/bottom_footer.php");

?>
