<?php
/*
 +-------------------------------------------------------------------------+
 | Nagios Plugin 0.1a for cacti 0.8.6f                                     |
 | Copyright (C) 2005 Billy Gunn (billy@gunn.org)                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti and Nagios are the copyright of their respective owners.          |
 |									   |
 | Code used throughout this program was borrowed from various places:     |
 |	- Cacti								   |
 |	- Nagios							   |
 |	- Nagios-db							   |
 |	- Cacti Plugin Architecture					   |
 +-------------------------------------------------------------------------+
*/

chdir('../../');
include_once("./include/auth.php");
include_once("./include/config.php");
include("top_npc_header.php");



if (isset($_POST["type"])) {
	hostReport();
} else {
	drawForm();
}

function hostReport() {

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";
	$rowColor = $background1;

        /*  
	   This code comes from Nagios-db with some hacks by me to support
	   reporting on a single host. The SQL is designed to query
	   availability by hostgroup while returning results for individual
	   hosts as well. In order to report on just a host or group of 
	   hosts I do an additional query to find the hostgroups they belong
           to and query as normal on the hostgroups. Then I just filter
	   on the hosts that were passed in for display.
	*/
        function hostAvailability($startTime, $stopTime, $hostgroups)
        {

		
		if ($_POST["type"] == 1) {
			// We are a host report
			$i = 0;
			$hosts = $hostgroups;
			$hostCount = count($hosts);
			$query = "";
			for($i = 0; $i < $hostCount; $i++) {
				$query .= "hostid = " . $hosts[$i] . " ";
				if ($i != ($hostCount - 1)) {
					$query = $query . "or ";
				}
			}
			$hostgroups = db_fetch_assoc("select groupid from npc_hostgroup_membership where $query group by groupid");
                	$hostgroupCount = count($hostgroups);
		} elseif ($_POST["type"] == 2) {
			// We are a hostgroup report
                	$hostgroupCount = count($hostgroups);
		}
				

                /* conforms to postgres summarize_host_states_by_hostgroup SP */
                $sql = "        select
                                                        npc_host_history.hostid,
                                                        groupid,
                                                        soft_state,
                                                        case when lasted is null then ";

                if ($startTime == "null") {
                        if ($stopTime == "null") {
                                $sql .= "unix_timestamp() - started else lasted end as duration from npc_host_history,npc_hostgroup_membership where npc_host_history.hostid = npc_hostgroup_membership.hostid and groupid in (";
                        } else {
                                $sql .= "case when unix_timestamp() > $stopTime then $stopTime - started else unix_timestamp() - started end else case when started+lasted > $stopTime then $stopTime - started else lasted end end as duration from npc_hostgroup_membership,npc_host_history where npc_host_history.hostid = npc_hostgroup_membership.hostid and started <=  $stopTime and groupid in (";
                        }
                } else {
                        if ($stopTime == "null") {
                                $sql .= "unix_timestamp() - started else lasted end as duration from npc_hostgroup_membership,npc_host_history where npc_hostgroup_membership.hostid = npc_host_history.hostid and started + coalesce(lasted,unix_timestamp()-started) >  $startTime and groupid in (";
                        } else {
                                $sql .= "case when unix_timestamp() > $stopTime then $stopTime - started else unix_timestamp() - started end else case when started+lasted > $stopTime then $stopTime - started else lasted end end as duration from npc_hostgroup_membership, npc_host_history where npc_host_history.hostid = npc_hostgroup_membership.hostid and started + coalesce(lasted,unix_timestamp() - started) > $startTime and started <= $stopTime and groupid in (";
                        }
                }

                $includePending = FALSE;

		
		if ($_POST["type"] == 1) {
			for($i = 0; $i < $hostgroupCount; $i++) {
        	                if ($hostgroups[$i]["groupid"] == "0") {
                	                $includePending = TRUE;
                        	}

                        	// yay for sql insertion attacks!
                        	$sql = $sql . $hostgroups[$i]["groupid"];
                        	if($i < $hostgroupCount - 1) {
                                	$sql = $sql . ",";
                        	}
                	}
		} elseif ($_POST["type"] == 2) {
                	$i = 0;
	                foreach($hostgroups as $value) {
	                        if ($value == "0") {
                	                $includePending = TRUE;
                        	}

                        	// yay for sql insertion attacks!
                        	$sql = $sql . $hostgroups[$i]["groupid"];
                        	if($i < $hostgroupCount - 1) {
                                	$sql = $sql . ",";
                        	}
                        	$i++;
                	}
		}

                $sql = $sql . ")";

                /* conforms to postgres summarize_grouped_host_states_by_hostgroup SP */
                /* wrap first query in this one */
                $sql = "
                select npc_host.configured, shs.groupid, npc_host.name, soft_state, sum(shs.duration) as duration, shsTotal.t
                from npc_host,($sql) as shs,(select hostid,sum(duration) as t
                from ($sql) as tmp group by hostid) as shsTotal where shsTotal.hostid = shs.hostid and npc_host.id = shs.hostid group by shs.groupid, npc_host.name,soft_state,shsTotal.t,npc_host.configured";


                /* our final wrap, what we could call if mysql had stored procs ;) */
                $sql = "        select
                                                        coalesce(npc_hostgroup.alias,'[no group]') as hostgroup,
                                                        shgs.name as hostname,
                                                        soft_state,
                                                        round((duration/t),5) as percent
                                                from
                                                        npc_hostgroup,
                                                        ($sql)  as shgs
                                                where
                                                        shgs.groupid = npc_hostgroup.id and
                                                        shgs.configured = TRUE
                                                order by
                                                        hostname";

                return($sql);
        } // End hostAvailability()





        function formatTime($time)
        {

                $days = floor($time/60/60/24);
                $time -= $days*60*60*24;
                $hours = floor($time/60/60);
                $time -= $hours*60*60;
                $minutes = floor($time/60);
                $time -= $minutes*60;
                $seconds = $time;

                return ($days . "d " . $hours . "h " . $minutes . "m " . $seconds . "s");
        }

        if($_POST["startBound"] == 1)
        {
                $startTime = mktime(0,0,0,$_POST["startMonth"],$_POST["startDay"],$_POST["startYear"]);
                $startTitle = $_POST["startYear"] . "-" . $_POST["startMonth"] . "-" . $_POST["startDay"];
        }
        else
        {
                $startTime = "null";
                $startTitle = "the beginning";
        }


        if($_POST["stopBound"] == 1)
        {
                $stopTime = mktime(0,0,0,$_POST["stopMonth"],$_POST["stopDay"],$_POST["stopYear"]);
                $stopTitle = $_POST["stopYear"] . "-" . $_POST["stopMonth"] . "-" . $_POST["stopDay"];
        }
        else
        {
                $stopTime = "null";
                $stopTitle = "now";
        }
?>

   <!-- Display the report -->

   <table width="98%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><h3><strong>
		<?php
                        if ($_POST["type"] == 1) {
				echo "Host Availability Report";
			} elseif ($_POST["type"] == 2) {
				echo "Hostgroup Availability Report";
			}
		?>
	   </strong>
	  </h3>
	</td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
               <thead>
                  <tr class="textSubHeaderDark" bgcolor='#6d88ad'>
		   <?php
			if ($_POST["type"] == 1) {
	       			echo "<td align='center'>Host</td>";
			} elseif ($_POST["type"] == 2) {
	       			echo "<td align='center'>Hostgroup</td>";
			}
		   ?>
	       		<td align='center'>% Time Up</td>
        		<td align='center'>% Time Down</td>
        		<td align='center'>% Time Unreachable</td>
        		<td align='center'>% Time Undetermined</td>
      	          </tr>
               </thead>
<?php

	$sql = hostAvailability($startTime, $stopTime, isset($_POST["hostgroups"]) ? $_POST["hostgroups"] : NULL);
	$q = db_fetch_assoc("$sql");

        $row_count = count($q);

        if($row_count == 0)
        {
                echo "<tr bgcolor='$rowColor'><td colspan=6><i>No matching hostgroups in the given period.</i></td></tr>";
        }

        // Walk our result set and move as much as we can into arrays
        $hostgroupAverages = array();

        for($i = 0; $i < $row_count; $i++)
        {
                if(!array_key_exists($q[$i]["hostgroup"],$hostgroupAverages))
                {
                        $hostgroupAverages[$q[$i]["hostgroup"]] = array(        "hostname" => $q[$i]["hostgroup"],
                                                                        "OK" => 0,
                                                                        "Bad" => 0,
                                                                        "Unreachable" => 0,
                                                                        "Unknown" => 0,
                                                                        "nodes" => array());
                }

                if(!array_key_exists( $q[$i]["hostname"],$hostgroupAverages[$q[$i]["hostgroup"]]["nodes"]))
                {
                        $hostgroupAverages[$q[$i]["hostgroup"]]["nodes"][$q[$i]["hostname"]] = array("hostname" => $q[$i]["hostname"],
                                                                        "OK" => 0,
                                                                        "Bad" => 0,
                                                                        "Unreachable" => 0,
                                                                        "Unknown" => 0);
                }

                switch($q[$i]["soft_state"])
                {
                        case "-1":
                                $hostgroupAverages[$q[$i]["hostgroup"]]["nodes"][$q[$i]["hostname"]]["Unknown"] = 100*$q[$i]["percent"];
                                break;
                        case "0":
                                $hostgroupAverages[$q[$i]["hostgroup"]]["nodes"][$q[$i]["hostname"]]["OK"] = 100*$q[$i]["percent"];
                                break;
                        case "1":
                                $hostgroupAverages[$q[$i]["hostgroup"]]["nodes"][$q[$i]["hostname"]]["Bad"] = 100*$q[$i]["percent"];
                                break;
                        case "2":
                                $hostgroupAverages[$q[$i]["hostgroup"]]["nodes"][$q[$i]["hostname"]]["Unreachable"] = 100*$q[$i]["percent"];
                                break;
                }
        }

        // now that we have all the data out of the result set in into our arrays, walk those arrays and do our calculations
        foreach($hostgroupAverages as $thisHostgroupAverage)
        {
                $nodeCount = 0;
                $totalOK = 0;
                $totalBad = 0;
                $totalUnreachable = 0;
                $totalUnknown = 0;

                foreach($thisHostgroupAverage["nodes"] as $thisNode)
                {
                        $hostgroupAverages[$thisHostgroupAverage["hostname"]]["nodes"][$thisNode["hostname"]]["Unknown"] = 100 - $thisNode["OK"] - $thisNode["Bad"] - $thisNode["Unreachable"];
                        $nodeCount++;
                        $totalOK = $totalOK + $thisNode["OK"];
                        $totalBad += $thisNode["Bad"];
                        $totalUnreachable += $thisNode["Unreachable"];
                        $totalUnknown += $thisNode["Unknown"];
                }

                $hostgroupAverages[$thisHostgroupAverage["hostname"]]["OK"] = $totalOK/$nodeCount;
                $hostgroupAverages[$thisHostgroupAverage["hostname"]]["Bad"] = $totalBad/$nodeCount;
                $hostgroupAverages[$thisHostgroupAverage["hostname"]]["Unknown"] = $totalUnknown/$nodeCount;
                $hostgroupAverages[$thisHostgroupAverage["hostname"]]["Unreachable"] = $totalUnreachable/$nodeCount;
        }

	// Ok, now we're ready to start dumping data.
        foreach ($hostgroupAverages as $groupAverages)
        {
                if($rowColor == $background1)
                {
                        $rowColor = $background2;
                }
                else
                {
                        $rowColor = $background1;
                }

		// Display hostgroup availability
		if ($_POST["type"] == 2) {
	                echo "<tr>";
	                echo "<td bgcolor=\"" . $rowColor . "\">";
	                echo "<b>" . $groupAverages["hostname"] . "</b>";
	                echo "</td>";
	                echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
	                echo "<b>" . abs(round($groupAverages["OK"],5)) . "</b>";
	                echo "</td>\n";
	                echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
	                echo "<b>" . abs(round($groupAverages["Bad"],5)) . "</b>";
	                echo "</td>\n";
	                echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
	                echo "<b>" . abs(round($groupAverages["Unreachable"],5)) . "</b>";
	                echo "</td>\n";
	                echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
	                echo "<b>" . abs(round($groupAverages["Unknown"],5)) . "</b>";
	                echo "</td>";
	                echo "</tr>";
		}

                if(isset($_POST["showHosts"]))
                {
                        foreach ($groupAverages["nodes"] as $thisNode)
                        {
                                if($rowColor == $background1)
                                {
                                        $rowColor = $background2;
                                }
                                else
                                {
                                        $rowColor = $background1;
                                }

				/* This foreach sets up a filter to filter on the selected hosts.
				   If my SQL was better we could avoid this extra loop and the many 
				   queries that result from it.
				*/	
                        	foreach ($_POST["hostgroups"] as $hostid) {
					$host = db_fetch_cell("select name from npc_host where id = $hostid");
					if ($thisNode["hostname"] != $host) {
						continue;
					}
                                	echo "<tr>";
                                	echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
                                	echo "<a href='extinfo.php?type=1&hostid=$hostid&hostname=$host'>$host</a>";
                                	echo "</td>";
                                	echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
                                	echo abs(round($thisNode["OK"],5));
                                	echo "</td>";
                                	echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
                                	echo abs(round($thisNode["Bad"],5));
                                	echo "</td>";
                                	echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
                                	echo abs(round($thisNode["Unreachable"],5));
                                	echo "</td>";
                                	echo "<td align=\"center\" bgcolor=\"" . $rowColor . "\">";
                                	echo abs(round($thisNode["Unknown"],5));
                                	echo "</td>";
                                	echo "</tr>";
				}
                        }
                }
        }

?>
			</table>
		</td>
	</tr>
</table>

<?php } // End report() ?>




<?php

function drawForm() {

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";

	if ($_REQUEST["type"] == 1) {
		$title = "Host Availability";
	} else {
		$title = "Hostgroup Availability";
	}
?>

<table width="98%" border="0" align="center">
   <tr class="textHeaderDark" bgcolor='#00438C'>
      <td align="center"><strong><?php echo $title; ?></strong></td>
   </tr>
   <tr>
      <td width="40%" valign="top">
         <table width="100%" align="center" cellpadding="3">

		<FORM NAME="gr" ACTION="" method="post">
	       <INPUT TYPE='hidden' NAME='type' VALUE='<?php echo $_REQUEST["type"]; ?>'>
	    <tr bgcolor='<?php echo $background1; ?>'>
	       <td width='50%'>
		  <?php 
		     if ($_REQUEST["type"] == 1) {
		     	echo "<font class='textEditTitle'>Host(s):</font><br>";
		  	echo "Select which host(s) to report availability on.";
		     } else {
			echo "<font class='textEditTitle'>Hostgroup(s):</font><br>";
		  	echo "Select which Hostgroup(s) to report availability on.";
		     }
		  ?>
	       </td>
	       <td>
                  <select multiple size="5" width="100%" name="hostgroups[]">
		  <?php
		      $rightNow = time();
		      if ($_REQUEST["type"] == 1) {
		      	  $hosts = db_fetch_assoc("select id,name from npc_host");
	              	  $hostCount = count($hosts);
	              	  for($i = 0; $i < $hostCount; $i++) {
	              	   	$thisID = $hosts[$i]["id"];
	                   	$thisName = $hosts[$i]["name"];

	                   	// note that if thisName includes some HTML, that will be a problem
	                   	echo "<option value=\"$thisID\">$thisName</option>";
       	 	      	  }
		      } else {
                      	  echo "<option value='0'>[No Group]</option>";
		      	  $groups = db_fetch_assoc("select id,alias from npc_hostgroup where id > 0");
	              	  $groupCount = count($groups);
	              	  for($i = 0; $i < $groupCount; $i++) {
	              	   	$thisID = $groups[$i]["id"];
	                   	$thisName = $groups[$i]["alias"];

	                   	// note that if thisName includes some HTML, that will be a problem
	                   	echo "<option value=\"$thisID\">$thisName</option>";
       	 	      	  }
		      }

		  ?>
        	  </select>
	       </td>
	    </tr>
	    <tr bgcolor='<?php echo $background2; ?>'>
	       <td width='50%'>
		  <?php
		     	if ($_REQUEST["type"] == 2) {
                  		echo "<font class='textEditTitle'> Show Hosts:</font><br>";
		  		echo "Check to view availability by host.";
			}
		  ?>
		  &nbsp;<br>&nbsp;
               </td>
               <td>
		  <?php
		     	if ($_REQUEST["type"] == 1) {
                                echo "<INPUT TYPE='hidden' value='1' name='showHosts'>";
			} elseif ($_REQUEST["type"] == 2) {
         	  		echo "<input type=checkbox value='0' name='showHosts'>";
			}
		  ?>
               </td>
            </tr>
	    <tr bgcolor='<?php echo $background1; ?>'>
	       <td width='50%'>
                  <font class='textEditTitle'>Unbounded Start Date:</font><br>
		  Check to start with the oldest data.
               </td>
               <td>
         	  <input type=radio value="0" name="startBound" onClick="disablestart()">
               </td>
            </tr>
	    <tr bgcolor='<?php echo $background2; ?>'>
	       <td width='50%'>
                  <font class='textEditTitle'>Bounded Start Date:</font><br>
		  Check to start at the specified date.
               </td>
               <td>
         	  <input type=radio value="1" name="startBound" onClick="enablestart()" checked>
               </td>
            </tr>
	    <tr bgcolor='<?php echo $background1; ?>'>
	       <td width='50%'>
                  <font class='textEditTitle'>Start Date:</font><br>
		  Specify the report start date.
               </td>
               <td>
	          <input type=text value="<?php echo date("Y",$rightNow-2419200); ?>" name="startYear" id="startYear" size="4" maxlength="4" onKeyPress="return numbersonly(this, event)">
	          -
	          <select name=startMonth id="startMonth">
	          <option value=1 <?php if(1 == date("n",$rightNow-2419200)) echo "selected"; ?>>Jan</option>
	          <option value=2 <?php if(2 == date("n",$rightNow-2419200)) echo "selected"; ?>>Feb</option>
	          <option value=3 <?php if(3 == date("n",$rightNow-2419200)) echo "selected"; ?>>Mar</option>
	          <option value=4 <?php if(4 == date("n",$rightNow-2419200)) echo "selected"; ?>>Apr</option>
	          <option value=5 <?php if(5 == date("n",$rightNow-2419200)) echo "selected"; ?>>May</option>
	          <option value=6 <?php if(6 == date("n",$rightNow-2419200)) echo "selected"; ?>>Jun</option>
	          <option value=7 <?php if(7 == date("n",$rightNow-2419200)) echo "selected"; ?>>Jul</option>
	          <option value=8 <?php if(8 == date("n",$rightNow-2419200)) echo "selected"; ?>>Aug</option>
	          <option value=9 <?php if(9 == date("n",$rightNow-2419200)) echo "selected"; ?>>Sep</option>
	          <option value=10 <?php if(10 == date("n",$rightNow-2419200)) echo "selected"; ?>>Oct</option>
	          <option value=11 <?php if(11 == date("n",$rightNow-2419200)) echo "selected"; ?>>Nov</option>
	          <option value=12 <?php if(12 == date("n",$rightNow-2419200)) echo "selected"; ?>>Dec</option>
	          </select>
	          -
	          <input type=text value="<?php echo date("j",$rightNow-2419200); ?>" name="startDay" id="startDay" size="2" maxlength="2" onKeyPress="return numbersonly(this, event)">
               </td>
            </tr>
	    <tr bgcolor='<?php echo $background2; ?>'>
	       <td width='50%'>
                  <font class='textEditTitle'>Unbounded Stop Date:</font><br>
		  Check to stop with the latest data.
               </td>
               <td>
         	  <input type=radio value="0" name="stopBound" onClick="disablestop()">
               </td>
            </tr>
	    <tr bgcolor='<?php echo $background1; ?>'>
	       <td width='50%'>
                  <font class='textEditTitle'>Bounded Stop Date:</font><br>
		  Check to stop at the specified date.
               </td>
               <td>
         	  <input type=radio value="1" name="stopBound" onClick="enablestop()" checked>
               </td>
            </tr>
	    <tr bgcolor='<?php echo $background2; ?>'>
	       <td width='50%'>
                  <font class='textEditTitle'>Stop Date:</font><br>
		  Specify the report stop date.
               </td>
               <td>
        	  <input type=text value="<?php echo date("Y",$rightNow); ?>" name="stopYear" id="stopYear" size="4" maxlength="4" onKeyPress="return numbersonly(this, event)">
	          -
	          <select name=stopMonth id="stopMonth">
	          <option value=1 <?php if(1 == date("n",$rightNow)) echo "selected"; ?>>Jan</option>
	          <option value=2 <?php if(2 == date("n",$rightNow)) echo "selected"; ?>>Feb</option>
	          <option value=3 <?php if(3 == date("n",$rightNow)) echo "selected"; ?>>Mar</option>
	          <option value=4 <?php if(4 == date("n",$rightNow)) echo "selected"; ?>>Apr</option>
	          <option value=5 <?php if(5 == date("n",$rightNow)) echo "selected"; ?>>May</option>
	          <option value=6 <?php if(6 == date("n",$rightNow)) echo "selected"; ?>>Jun</option>
	          <option value=7 <?php if(7 == date("n",$rightNow)) echo "selected"; ?>>Jul</option>
	          <option value=8 <?php if(8 == date("n",$rightNow)) echo "selected"; ?>>Aug</option>
	          <option value=9 <?php if(9 == date("n",$rightNow)) echo "selected"; ?>>Sep</option>
	          <option value=10 <?php if(10 == date("n",$rightNow)) echo "selected"; ?>>Oct</option>
	          <option value=11 <?php if(11 == date("n",$rightNow)) echo "selected"; ?>>Nov</option>
	          <option value=12 <?php if(12 == date("n",$rightNow)) echo "selected"; ?>>Dec</option>
	          </select>
	          -
	          <input type=text value="<?php echo date("j",$rightNow); ?>" name="stopDay" id="stopDay" size="2" maxlength="2" onKeyPress="return numbersonly(this, event)">
               </td>
            </tr>
	 </table>

	 <br>
	 <table align='center' width='98%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>

		<tr>
			 <td bgcolor="#f5f5f5" align="right">
				<a href='<?php echo $_SERVER["HTTP_REFERER"]; ?>'><img src='../../images/button_cancel2.gif' alt='Cancel' align='absmiddle' border='0'></a>
				<input type='image' src='../../images/button_view.gif' alt='Save' align='absmiddle'>
			</td>
		</tr>
	</table>

	</form>






<?php 

}
include("./include/bottom_footer.php");
?>
