<?php
/*
 +-------------------------------------------------------------------------+
 | Nagios Plugin 0.1a for Cacti 0.8.6f					   |
 | Copyright (C) 2005 Billy Gunn (billy@gunn.org)                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti and Nagios are the copyright of their respective owners.          |
 +-------------------------------------------------------------------------+

*/

chdir('../../');
include_once("./include/auth.php");
include_once("./include/config.php");

// Refresh the page at a user supplied interval
header("Refresh: " . read_config_option("npc_refresh") . "; URL=" . $_SERVER["REQUEST_URI"]);
include("top_npc_header.php");

?>


   <table width="98%" border="0" align="center">
   <tr>
   <td>
      <table width="70%" border="0" align="center" valign="top">
      <thead>
      <tr class="textHeaderDark" bgcolor='#00438C'>
      <td align="center"><strong>Host Status Summary</strong></td>
      </tr>
      </thead>
      <tbody>
      <tr>
      <td width="40%" valign="top">
         <table width="100%" align="center" cellpadding="3">
         <thead>
         <tr align="center" class="textSubHeaderDark" bgcolor='#6d88ad'>
	 <td>Down</td>
	 <td>Unreachable</td>
	 <td>Up</td>
	 <td>Pending</td>
	 </tr>
	 </thead>
	 <tbody>
         <tr>

<?php

	$host_states = db_fetch_assoc("
	select
        	count(*) as count,
	        soft_state
	from
        	npc_host_history,
	        npc_host_check,
        	npc_host
	where
        	npc_host_check.hostid = npc_host.id and
	        npc_host.configured = TRUE and
	        npc_host_history.hostid = npc_host_check.hostid and
	        has_been_checked = TRUE and
	        lasted is null
	group by soft_state
	union
	select
	        count(*) as count,
	        -1 as soft_state
	from
	        npc_host_check,
	        npc_host
	where
	        npc_host.id = npc_host_check.hostid and
	        npc_host.configured = TRUE and
	        has_been_checked = FALSE");

        $row_count = count($host_states);

	/* Host Down */
        for($i = 0; $i < $row_count; $i++)
        {
                if($host_states[$i]["soft_state"] == 1 && $host_states[$i]["count"] != 0)
                {
                        echo "<td class='hostTotalsDOWN'>" . $host_states[$i]["count"] . "</td>";
                        break;
                }
        }
        if($i == $row_count) echo "<td class='hostTotals'>0</td>";


	/* Hosts Unreachable */
        for($i = 0; $i < $row_count; $i++)
        {
                if($host_states[$i]["soft_state"] == 2 && $host_states[$i]["count"] != 0)
                {
                        echo "<td class='hostTotalsUNREACHABLE'>" . $host_states[$i]["count"] . "</td>";
                        break;
                }
        }
        if($i == $row_count) echo "<td class='hostTotals'>0</td>";


	/* Host Up */
        for($i = 0; $i < $row_count; $i++)
        {
                if($host_states[$i]["soft_state"] == 0 && $host_states[$i]["count"] != 0)
                {
                        echo "<td class='hostTotalsUP'>" . $host_states[$i]["count"] . "</td>";
                        break;
                }
        }
        if($i == $row_count) echo "<td class='hostTotals'>0</td>";


	/* Host Pending */
        for($i = 0; $i < $row_count; $i++)
        {
                if($host_states[$i]["soft_state"] == -1 && $host_states[$i]["count"] != 0)
                {
                        echo "<td class='hostTotalsPENDING'>" . $host_states[$i]["count"] . "</td>";
                        break;
                }
        }
        if($i == $row_count) echo "<td class='hostTotals'>0</td>";

?>
         </tr>
         <tr><td>&nbsp;</td></tr>
         <tr><td>&nbsp;</td></tr>
         <tr><td>&nbsp;</td></tr>
         </tbody>
         </table>
      </td>
      </tr>
      </tbody>
      </table>
   </td>

   <td>
      <table width="70%" border="0" align="center">
      <thead>
      <tr class="textHeaderDark" bgcolor='#00438C'>
      <td align="center"><strong>Monitoring Performance Statistics</strong></td>
      </tr>
      </thead>
      <tbody>
      <tr>
      <td valign="top">
         <table width="100%" align="center" cellpadding="3">
         <thead>
         <tr class="textSubHeaderDark" bgcolor='#6d88ad'>
	 <td>Item</td>
	 <td>min</td>
	 <td>avg</td>
	 <td>max</td>
	 </tr>
	 </thead>
	 <tbody>

<?php
        $service_perf_data = db_fetch_assoc("select
                                                  min(check_execute_time) as min_execute_time,
                                                  max(check_execute_time) as max_execute_time,
                                                  avg(check_execute_time) as avg_execute_time,
                                                  min(check_latency) as min_latency,
                                                  max(check_latency) as max_latency,
                                                  avg(check_latency) as avg_latency
                                             from
                                                  npc_service_check,
                                                  npc_service
                                             where
                                                   npc_service.id = npc_service_check.serviceid and
                                                   npc_service.configured = TRUE and
                                                   npc_service.has_been_checked = TRUE");

?>
         <tr bgcolor="#F5F5F5">
         <td>Service Check Execution Time</td>
         <td><?=round($service_perf_data[0]["min_execute_time"],3)?></td>
         <td><?=round($service_perf_data[0]["avg_execute_time"],3)?></td>
         <td><?=round($service_perf_data[0]["max_execute_time"],3)?></td>
         </tr>
         <tr bgcolor="#E7E9F2">
         <td>Service Check Latency</td>
         <td><?=round($service_perf_data[0]["min_latency"],3)?></td>
         <td><?=round($service_perf_data[0]["avg_latency"],3)?></td>
         <td><?=round($service_perf_data[0]["max_latency"],3)?></td>
         </tr>
<?php
        $host_perf_data = db_fetch_assoc("select
                                               min(check_execute_time) as min_execute_time,
                                               max(check_execute_time) as max_execute_time,
                                               avg(check_execute_time) as avg_execute_time,
                                               min(check_latency) as min_latency,
                                               max(check_latency) as max_latency,
                                               avg(check_latency) as avg_latency
                                          from
                                               npc_host_check,
                                               npc_host
                                          where
                                               npc_host.id = npc_host_check.hostid and
                                               npc_host.configured = TRUE and
                                               npc_host.has_been_checked = TRUE");
?>
         <tr bgcolor="#F5F5F5">
         <td>Host Check Execution Time</td>
         <td><?=round($host_perf_data[0]["min_execute_time"],3)?></td>
         <td><?=round($host_perf_data[0]["avg_execute_time"],3)?></td>
         <td><?=round($host_perf_data[0]["max_execute_time"],3)?></td>
         </tr>
         <tr bgcolor="#E7E9F2">
         <td>Host Check Latency</td>
         <td><?=round($host_perf_data[0]["min_latency"],3)?></td>
         <td><?=round($host_perf_data[0]["avg_latency"],3)?></td>
         <td><?=round($host_perf_data[0]["max_latency"],3)?></td>
         </tr>

         </tbody>
         </table>
      </td>
      </tr>
      </tbody>
      </table>
   </td>
   </tr>


   <tr>
   <td>
      <table width="70%" border="0" align="center">
      <thead>
      <tr class="textHeaderDark" bgcolor='#00438C'>
      <td align="center"><strong>Service Status Summary</strong></td>
      </tr>
      </thead>
      <tbody>
      <tr>
      <td width="40%" valign="top">
         <table width="100%" align="center" cellpadding="3">
         <thead>
         <tr align="center" class="textSubHeaderDark" bgcolor='#6d88ad'>
         <td>Critical</td>
         <td>Warning</td>
         <td>Unknown</td>
         <td>Ok</td>
         <td>Pending</td>
         </tr>
         </thead>
         <tbody>
         <tr>

<?php

$service_states = db_fetch_assoc("
select
        coalesce(good.state,bad.state,pending.state) as state,
        coalesce(good.c,0) + coalesce(bad.c,0) + coalesce(pending.c,0) as total,
        coalesce(good.c,0) as good_hosts,
        coalesce(pending.c,0) as pending_hosts,
        coalesce(bad.c,0) as bad_hosts
from
        (
-- begin crappy full join hack since mysql doesn't have them, add our other states by hand
                select
                        tmp.c,
                        tmp.state
                from
                        (
                                select
                                        count(*) as c,
                                        npc_service_history.soft_state as state
                                from
                                        npc_service_history,
                                        npc_host_history,
                                        npc_service,
                                        npc_host
                                where
                                        npc_host_history.lasted is null and
                                        npc_host_history.soft_state = 0 and
                                        npc_host_history.hostid = npc_service.hostid and
                                        npc_service_history.serviceid = npc_service.id and
                                        npc_service.has_been_checked = TRUE and
                                        npc_service_history.lasted is null and
                                        npc_service.configured = TRUE and
                                        npc_host_history.hostid = npc_host.id and
                                        npc_host.has_been_checked = TRUE
                                group by state
                                union
                                select
                                        count(*) as c,
                                        -1 as state
                                from
                                        npc_service,
                                        npc_host_history,
                                        npc_host
                                where
                                        npc_host_history.hostid = npc_service.hostid and
                                        npc_host_history.lasted is null and
                                        npc_host_history.soft_state = 0 and
                                        npc_service.has_been_checked = FALSE and
                                        npc_service.configured = TRUE and
                                        npc_host_history.hostid = npc_host.id and
                                        npc_host.has_been_checked = TRUE
-- force em in
                                union
                                select
                                        0 as c,
                                        -1 as state
                                union
                                select
                                        0 as c,
                                        1 as state
                                union
                                select
                                        0 as c,
                                        2 as state
                                union
                                select
                                        0 as c,
                                        3 as state
                        ) as tmp
                group by
                        state
        ) good left join
        (
                select
                        count(*) as c,
                        npc_service_history.soft_state as state
                from
                        npc_service_history,
                        npc_service,
                        npc_host
                where
                        npc_host.id = npc_service.hostid and
                        npc_service_history.serviceid = npc_service.id and
                        npc_service.has_been_checked = TRUE and
                        npc_service_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_host.has_been_checked = FALSE
                group by state
                union
                select
                        count(*) as c,
                        -1 as state
                from
                        npc_service,
                        npc_host
                where
                        npc_service.hostid = npc_host.id and
                        npc_service.has_been_checked = FALSE and
                        npc_service.configured = TRUE and
                        npc_host.has_been_checked = FALSE
        ) pending on
        (
                pending.state = good.state
        ) left join
        (
                select
                        count(*) as c,
                        npc_service_history.soft_state as state
                from
                        npc_service_history,
                        npc_host_history,
                        npc_service,
                        npc_host
                where
                        npc_host_history.lasted is null and
                        npc_host_history.hostid = npc_service.hostid and
                        npc_service_history.serviceid = npc_service.id and
                        npc_service.has_been_checked = TRUE and
                        npc_service_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_host_history.hostid = npc_host.id and
                        npc_host.has_been_checked = TRUE and
                        npc_host_history.soft_state != 0
                group by state
                union
                select
                        count(*) as c,
                        -1 as state
                from
                        npc_service,
                        npc_host_history,
                        npc_host
                where
                        npc_host_history.hostid = npc_service.hostid and
                        npc_host_history.lasted is null and
                        npc_service.has_been_checked = FALSE and
                        npc_service.configured = TRUE and
                        npc_host_history.hostid = npc_host.id and
                        npc_host_history.soft_state != 0 and
                        npc_host.has_been_checked = TRUE
        ) bad on
        (
                bad.state = good.state
        )");

        $row_count = count($service_states);

	/* Service Critical */
        for($i = 0; $i < $row_count; $i++)
        {
                if($service_states[$i]["state"] == 2)
                {
			if($service_states[$i]["total"] > 0) {
	                        echo "<td class='serviceTotalsCRITICAL'>" . $service_states[$i]["total"] . "</td>";
			} else {
				echo "<td class='serviceTotals'>0</td>";
			}
                        break;
                }
        }


	/* Service Warning */
        for($i = 0; $i < $row_count; $i++)
        {
                if($service_states[$i]["state"] == 1)
                {
			if($service_states[$i]["total"] > 0) {
                        	echo "<td class='serviceTotalsWARNING'>" . $service_states[$i]["total"] . "</td>";
			} else {
				echo "<td class='serviceTotals'>0</td>";
			}
                        break;
                }
        }


	/* Service Unknown */
        for($i = 0; $i < $row_count; $i++)
        {
                if($service_states[$i]["state"] == 3)
                {
			if($service_states[$i]["total"] > 0) {
	                        echo "<td class='serviceTotalsUNKNOWN'>" . $service_states[$i]["total"] . "</td>";
			} else {
				echo "<td class='serviceTotals'>0</td>";
			}
                        break;
                }
        }


	/* Service Ok */
        for($i = 0; $i < $row_count; $i++)
        {
                if($service_states[$i]["state"] == 0)
                {
			if($service_states[$i]["total"] > 0) {
	                        echo "<td class='serviceTotalsOK'>" . $service_states[$i]["total"] . "</td>";
			} else {
				echo "<td class='serviceTotals'>0</td>";
			}
                        break;
                }
        }


	/* Service Pending */
        for($i = 0; $i < $row_count; $i++)
        {
                if($service_states[$i]["state"] == -1)
                {
			if($service_states[$i]["total"] > 0) {
	                        echo "<td class='serviceTotalsPENDING'>" . $service_states[$i]["total"] . "</td>";
			} else {
				echo "<td class='serviceTotals'>0</td>";
			}
                        break;
                }
        }
	?>
         </tr>
         </tbody>
         </table>
      </td>
      </tr>
      </tbody>
      </table>
   </td>
   </tr>

   <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
   <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
   <tr><td>&nbsp;</td><td>&nbsp;</td></tr>

<?php

$hostgroup_host_status = db_fetch_assoc("
select
        groupname,
        soft_state,
        count,
        groupid
from
        (
                select
                        npc_hostgroup.alias as groupname,
                        npc_hostgroup.id as groupid,
                        count(*) as count,
                        soft_state as soft_state
                from
                        npc_hostgroup,
                        npc_hostgroup_membership,
                        npc_host_history,
                        npc_host_check,
                        npc_host
                where
                        npc_host.id = npc_host_check.hostid and
                        npc_host.configured = TRUE and
                        npc_hostgroup.id = npc_hostgroup_membership.groupid and
                        npc_host_check.hostid = npc_hostgroup_membership.hostid and
                        npc_host_history.hostid = npc_host_check.hostid and
                        has_been_checked = TRUE and
                        lasted is null
                group by soft_state,npc_hostgroup.alias,npc_hostgroup.id
                union
                select
                        npc_hostgroup.alias as groupname,
                        npc_hostgroup.id as groupid,
                        count(*) as count,
                        -1 as soft_state
                from
                        npc_host_check,
                        npc_host,
                        npc_hostgroup,
                        npc_hostgroup_membership
                where
                        npc_host.id = npc_host_check.hostid and
                        npc_host.configured = TRUE and
                        npc_hostgroup.id = npc_hostgroup_membership.groupid and
                        npc_host_check.hostid = npc_hostgroup_membership.hostid and
                        has_been_checked = FALSE
                group by npc_hostgroup.alias,npc_hostgroup.id
                union
                select
                        '[no group]' as groupname,
                        0 as groupid,
                        count(*) as count,
                        -1 as soft_state
                from
                        npc_host,
                        npc_host_check
                where
                        npc_host.id = npc_host_check.hostid and
                        npc_host.configured = TRUE and
                        has_been_checked = FALSE and
                        hostid not in (select hostid from npc_hostgroup_membership)
                union
                select
                        '[no group]' as groupname,
                        0 as groupid,
                        count(*) as count,
                        soft_state as soft_state
                from
                        npc_host,
                        npc_host_history,
                        npc_host_check
                where
                        npc_host.id = npc_host_check.hostid and
                        npc_host.configured = TRUE and
                        npc_host_check.hostid not in (select hostid from npc_hostgroup_membership) and
                        npc_host_history.hostid = npc_host_check.hostid and
                        has_been_checked = TRUE and
                        lasted is null
                group by soft_state
        ) as tmp");

	$row_count = count($hostgroup_host_status);

	// okay, now that we have our results, populate some hashes in memory to ease the dumping out of them.
        $hostgroupHostStates = array();

        for($i = 0; $i < $row_count; $i++)
        {
                if(!array_key_exists($hostgroup_host_status[$i]["groupname"],$hostgroupHostStates))
                {
                        $hostgroupHostStates[$hostgroup_host_status[$i]["groupname"]] = array("name" => $hostgroup_host_status[$i]["groupname"],
                                                                "id" => $hostgroup_host_status[$i]["groupid"],
                                                                "Up" => 0,
                                                                "Down" => 0,
                                                                "Pending" => 0,
                                                                "Unreachable" => 0);
                }

                switch($hostgroup_host_status[$i]["soft_state"])
                {
                        case "-1":
                                $hostgroupHostStates[$hostgroup_host_status[$i]["groupname"]]["Pending"] = $hostgroup_host_status[$i]["count"];
                                break;
                        case "0":
                                $hostgroupHostStates[$hostgroup_host_status[$i]["groupname"]]["Up"] = $hostgroup_host_status[$i]["count"];
                                break;
                        case "1":
                                $hostgroupHostStates[$hostgroup_host_status[$i]["groupname"]]["Down"] = $hostgroup_host_status[$i]["count"];
                                break;
                        case "2":
                                $hostgroupHostStates[$hostgroup_host_status[$i]["groupname"]]["Unreachable"] = $hostgroup_host_status[$i]["count"];
                                break;
                }
        }

?>

   <tr>
   <td>
      <table width="100%" border="0" align="center">
         <thead>
	   <tr><td>&nbsp;</td></tr>
           <tr class="textHeaderDark" bgcolor='#00438C'>
              <td align="center"><strong>Hostgroup: Host Status</strong></td>
           </tr>
         </thead>
         <tbody>
           <tr>
              <td width="40%" valign="top">
                 <table width="100%" align="center" cellpadding="3">
                    <thead>
                       <tr align="left" class="textSubHeaderDark" bgcolor='#6d88ad'>
                          <td>Host Group</td>
                          <td>Down</td>
                          <td>Unreachable</td>
                          <td>Up</td>
                          <td>Pending</td>
                       </tr>
                    </thead>
         	    <tbody>
		    <?php
        		// now that we have all our data, it's time to start writing it out
			/* There seems to be a bug in Nagios that is causing all hostgroups
			   to show each host twice. I will divide the hosts totals by 2 until
			   the Nagios issue is resolved. */
			$background1 = "#F5F5F5";
                        $background2 = "#E7E9F2";
                        $rowColor = $background1;
			sort($hostgroupHostStates);
			foreach($hostgroupHostStates as $thisHostgroupHostState) {
         	 	       	echo "<tr bgcolor='$rowColor'>";
                		echo "<td align='left'>" . $thisHostgroupHostState["name"] . "</td>";

				if ($thisHostgroupHostState["Down"] == 0) {
					echo "<td>0</td>";
				} else {
                			echo "<td class='hostTotalsDOWN'>" . $thisHostgroupHostState["Down"] . "</td>";
				}

				if ($thisHostgroupHostState["Unreachable"] == 0) {
					echo "<td>0</td>";
				} else {
                			echo "<td class='hostTotalsUNREACHABLE'>" . $thisHostgroupHostState["Unreachable"] . "</td>";
				}

				if ($thisHostgroupHostState["Up"] == 0) {
					echo "<td>0</td>";
				} else {
                			echo "<td class='hostTotalsUP'>" . $thisHostgroupHostState["Up"] . "</td>";
				}

				if ($thisHostgroupHostState["Pending"] == 0) {
					echo "<td>0</td>";
				} else {
                			echo "<td class='hostTotalsPENDING'>" . $thisHostgroupHostState["Pending"] . "</td>";
				}

                		echo "</tr>";

				 /* Alternate the row colors */
                                if($rowColor == $background1) {
                                        $rowColor = $background2;
                                } else {
                                	$rowColor = $background1;
				}
        		}
		    ?>
                    </tbody>
                 </table>
              </td>
           </tr>
        </tbody>
     </table>
   </td>

<?php
$hostgroup_service_status = db_fetch_assoc("
select
        groupname,
        state,
        total,
        good_hosts,
        pending_hosts,
        bad_hosts,
        groupid
from
        (
            select
                    coalesce(npc_hostgroup.alias,'[no group]') as groupname,
                    coalesce(good.groupid,bad.groupid,pending.groupid) as groupid,
                    coalesce(good.state,bad.state,pending.state) as state,
                    coalesce(good.c,0) + coalesce(bad.c,0) + coalesce(pending.c,0) as total,
                    coalesce(good.c,0) as good_hosts,
                    coalesce(pending.c,0) as pending_hosts,
                    coalesce(bad.c,0) as bad_hosts
            from
                    npc_hostgroup,
                    (
                            select
                                    count(*) as c,
                                    npc_service_history.soft_state as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_service_history,
                                    npc_host_history,
                                    npc_service,
                                    npc_hostgroup_membership
                            where
                                    npc_host_history.hostid = npc_hostgroup_membership.hostid and
                                    npc_host_history.lasted is null and
                                    npc_host_history.soft_state = 0 and
                                    npc_host_history.hostid = npc_service.hostid and
                                    npc_service_history.serviceid = npc_service.id and
                                    npc_service.has_been_checked = TRUE and
                                    npc_service_history.lasted is null and
                                    npc_service.configured = TRUE
                            group by state,groupid
                            union
                            select
                                    count(*) as c,
                                    npc_service_history.soft_state as state,
                                    0 as groupid
                            from
                                    npc_service_history,
                                    npc_host_history,
                                    npc_service
                            where
                                    npc_host_history.hostid not in (select hostid from npc_hostgroup_membership) and
                                    npc_host_history.lasted is null and
                                    npc_host_history.soft_state = 0 and
                                    npc_host_history.hostid = npc_service.hostid and
                                    npc_service_history.serviceid = npc_service.id and
                                    npc_service.has_been_checked = TRUE and
                                    npc_service_history.lasted is null and
                                    npc_service.configured = TRUE
                            group by state
-- begin crappy full join hack since mysql doesn't have them, add our other values
                            union
                            select
                                    0 as c,
                                    -1 as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_hostgroup_membership
                            union
                            select
                                    0 as c,
                                    1 as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_hostgroup_membership
                            union
                            select
                                    0 as c,
                                    2 as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_hostgroup_membership
                            union
                            select
                                    0 as c,
                                    3 as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_hostgroup_membership
                    ) good left join
                    (
                            select
                                    count(*) as c,
                                    -1 as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_service,
                                    npc_hostgroup_membership
                            where
                                    npc_hostgroup_membership.hostid = npc_service.hostid and
                                    npc_service.has_been_checked = FALSE and
                                    npc_service.configured = TRUE
                            group by groupid
                            union
                            select
                                    count(*) as c,
                                    -1 as state,
                                    0 as groupid
                            from
                                    npc_service
                            where
                                    npc_service.hostid not in (select hostid from npc_hostgroup_membership) and
                                    npc_service.has_been_checked = FALSE and
                                    npc_service.configured = TRUE
                    ) pending on
                    (
                            pending.state = good.state and
                            pending.groupid = good.groupid
                    ) left join
                    (
                            select
                                    count(*) as c,
                                    npc_service_history.soft_state as state,
                                    npc_hostgroup_membership.groupid as groupid
                            from
                                    npc_service_history,
                                    npc_host_history,
                                    npc_service,
                                    npc_hostgroup_membership
                            where
                                    npc_host_history.hostid = npc_hostgroup_membership.hostid and
                                    npc_host_history.lasted is null and
                                    npc_host_history.soft_state != 0 and
                                    npc_host_history.hostid = npc_service.hostid and
                                    npc_service_history.serviceid = npc_service.id and
                                    npc_service.has_been_checked = TRUE and
                                    npc_service_history.lasted is null and
                                    npc_service.configured = TRUE
                            group by state,groupid
                            union
                            select
                                    count(*) as c,
                                    npc_service_history.soft_state as state,
                                    0 as groupid
                            from
                                    npc_service_history,
                                    npc_host_history,
                                    npc_service
                            where
                                    npc_host_history.hostid not in (select hostid from npc_hostgroup_membership) and
                                    npc_host_history.lasted is null and
                                    npc_host_history.soft_state != 0 and
                                    npc_host_history.hostid = npc_service.hostid and
                                    npc_service_history.serviceid = npc_service.id and
                                    npc_service.has_been_checked = TRUE and
                                    npc_service_history.lasted is null and
                                    npc_service.configured = TRUE
                            group by state
                    ) bad on
                    (
                            bad.state = good.state and
                            bad.groupid = good.groupid
                    )
            where
                    npc_hostgroup.id = coalesce(good.groupid,bad.groupid,pending.groupid) having total > 0
            order by groupname, state
)  as tmp");

$row_count = count($hostgroup_service_status);

        // okay, now that we have our results, populate some hashes in memory to ease the dumping out of them.
        $hostgroupServiceStates = array();

        for($i = 0; $i < $row_count; $i++)
        {
                if(!array_key_exists($hostgroup_service_status[$i]["groupname"],$hostgroupServiceStates))
                {
                        $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]] = array("name" => $hostgroup_service_status[$i]["groupname"],
                                                                "id" => $hostgroup_service_status[$i]["groupid"],
                                                                "Critical" => 0,
                                                                "CriticalGood" => 0,
                                                                "CriticalPending" => 0,
                                                                "CriticalBad" => 0,
                                                                "Unknown" => 0,
                                                                "UnknownGood" => 0,
                                                                "UnknownPending" => 0,
                                                                "UnknownBad" => 0,
                                                                "Warning" => 0,
                                                                "WarningGood" => 0,
                                                                "WarningPending" => 0,
                                                                "WarningBad" => 0,
                                                                "OK" => 0,
                                                                "OKGood" => 0,
                                                                "OKPending" => 0,
                                                                "OKBad" => 0,
                                                                "Pending" => 0,
                                                                "PendingGood" => 0,
                                                                "PendingPending" => 0,
                                                                "PendingBad" => 0);
                }

                switch($hostgroup_service_status[$i]["state"])
                {
                        case "-1":
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["Pending"] = $hostgroup_service_status[$i]["total"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["PendingGood"] = $hostgroup_service_status[$i]["good_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["PendingPending"] = $hostgroup_service_status[$i]["pending_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["PendingBad"] = $hostgroup_service_status[$i]["bad_hosts"];
                                break;
                        case "0":
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["OK"] = $hostgroup_service_status[$i]["total"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["OKGood"] = $hostgroup_service_status[$i]["good_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["OKPending"] = $hostgroup_service_status[$i]["pending_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["OKBad"] = $hostgroup_service_status[$i]["bad_hosts"];
                                break;
                        case "1":
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["Warning"] = $hostgroup_service_status[$i]["total"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["WarningGood"] = $hostgroup_service_status[$i]["good_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["WarningPending"] = $hostgroup_service_status[$i]["pending_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["WarningBad"] = $hostgroup_service_status[$i]["bad_hosts"];
                                break;
                        case "2":
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["Critical"] = $hostgroup_service_status[$i]["total"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["CriticalGood"] = $hostgroup_service_status[$i]["good_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["CriticalPending"] = $hostgroup_service_status[$i]["pending_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["CriticalBad"] = $hostgroup_service_status[$i]["bad_hosts"];
                                break;
                        case "3":
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["Unknown"] = $hostgroup_service_status[$i]["total"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["UnknownGood"] = $hostgroup_service_status[$i]["good_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["UnknownPending"] = $hostgroup_service_status[$i]["pending_hosts"];
                                $hostgroupServiceStates[$hostgroup_service_status[$i]["groupname"]]["UnknownBad"] = $hostgroup_service_status[$i]["bad_hosts"];
                                break;
                }
        }


?>

   <td>
      <table width="80%" border="0" align="center" valign="top">
         <thead>
           <tr class="textHeaderDark" bgcolor='#00438C'>
              <td align="center"><strong>Hostgroup: Service Status</strong></td>
           </tr>
         </thead>
         <tbody>
           <tr>
              <td width="40%" valign="top">
                 <table width="100%" align="center" cellpadding="3">
                    <thead>
                       <tr align="center" class="textSubHeaderDark" bgcolor='#6d88ad'>
                          <td>Host Group</td>
                          <td>Critical</td>
                          <td>Warning</td>
                          <td>Unknown</td>
                          <td>Ok</td>
                          <td>Pending</td>
                       </tr>
                    </thead>
         	    <tbody>

		    <?php
			$background1 = "#F5F5F5";
			$background2 = "#E7E9F2";
			$rowColor = $background1;
			sort ($hostgroupServiceStates);
			foreach ($hostgroupServiceStates as $thisHostgroupServiceState) {

                		echo "<tr bgcolor='$rowColor'>";

                		echo "<td align='left'>" . $thisHostgroupServiceState["name"] . "</td>";

				if ($thisHostgroupServiceState["Critical"] == 0) {
					echo "<td>0</td>";
				} else {
                			echo "<td class='serviceTotalsCRITICAL'>";
                			echo $thisHostgroupServiceState["Critical"];
				}
                		echo "</td>";

				if ($thisHostgroupServiceState["Warning"] == 0) {
					echo "<td>0</td>";
				} else {
                			echo "<td class='serviceTotalsWARNING'>";
                			echo $thisHostgroupServiceState["Warning"];
				}
                		echo "</td>";

				if ($thisHostgroupServiceState["Unknown"] == 0) {
					echo "<td>0</td>";
				} else {
		                	echo "<td class='serviceTotalsUNKNOWN'>";
               		 		echo $thisHostgroupServiceState["Unknown"];
				}
		                echo "</td>";

				if ($thisHostgroupServiceState["OK"] == 0) {
					echo "<td>0</td>";
				} else {
               		 		echo "<td class='serviceTotalsOK'>";
		                	echo $thisHostgroupServiceState["OK"];
				}
               		 	echo "</td>";

				if ($thisHostgroupServiceState["Pending"] == 0) {
					echo "<td>0</td>";
				} else {
		                	echo "<td class='serviceTotalsPENDING'>";
               		 		echo $thisHostgroupServiceState["Pending"];
				}
		                echo "</td>";

      				echo "</tr>";

				/* Alternate the row colors */
		                if($rowColor == $background1) {
                		        $rowColor = $background2;
		                } else {
                	        $rowColor = $background1;
                }

			}
		   ?>

                    </tbody>
                 </table>
              </td>
           </tr>
        </tbody>
     </table>
   </td>




   </tr>
   </table>

<?php

include("./include/bottom_footer.php");

?>
