<?php
/*
 +-------------------------------------------------------------------------+
 | Nagios Plugin 0.1a for Cacti 0.8.6f                                     |
 | Copyright (C) 2005 Billy Gunn (billy@gunn.org)                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti and Nagios are the copyright of their respective owners.          |
 +-------------------------------------------------------------------------+
*/

function plugin_init_npc() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['npc'] = 'npc_show_tab';
	$plugin_hooks['top_graph_header_tabs']['npc'] = 'npc_show_tab';
	$plugin_hooks['config_arrays']['npc'] = 'npc_config_arrays';
	$plugin_hooks['draw_navigation_text']['npc'] = 'npc_draw_navigation_text';
	$plugin_hooks['config_form']['npc'] = 'npc_config_form';
	$plugin_hooks['api_device_save']['npc'] = 'npc_api_device_save';
	$plugin_hooks['top_graph_refresh']['npc'] = 'npc_top_graph_refresh';
	$plugin_hooks['config_settings']['npc'] = 'npc_config_settings';
}

function npc_config_settings () {
	global $tabs, $settings;
	$tabs["npc"] = "NPC";

	$temp = array(
		"npc_header" => array(
			"friendly_name" => "Remote Command Execution",
			"method" => "spacer",
			),
		"nagios_commands" => array(
			"friendly_name" => "Remote Commands",
			"description" => "Allow commands to be sent to Nagios via NPC.",
			"method" => "checkbox",
			),
		"path_nagios_cmd" => array(
			"friendly_name" => "Nagios Command File Path",
			"description" => "The path to nagios.cmd",
			"method" => "textbox",
			"max_length" => 255,
			),
		"npc_refresh" => array(
                        "friendly_name" => "Refresh Interval",
                        "description" => "This is the time in seconds before NPC pages refresh.",
                        "method" => "textbox",
			"default" => "300",
                        "max_length" => 3,
                        ),
	);
	if (isset($settings["npc"]))
		$settings["npc"] = array_merge($settings["npc"], $temp);
	else
		$settings["npc"]=$temp;
}

function npc_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('npc.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('npc.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/npc/npc.php"><img src="' . $config['url_path'] . 'plugins/npc/images/tab_npc.gif" alt="Nagios" align="absmiddle" border="0"></a>';

	}
	npc_setup_table();

}

function npc_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[32]='View NPC';
	$user_auth_realm_filenames['npc.php'] = 32;
	$user_auth_realm_filenames['statusDetail.php'] = 32;
	$user_auth_realm_filenames['extinfo.php'] = 32;
	$user_auth_realm_filenames['command.php'] = 32;
	$user_auth_realm_filenames['hostList.php'] = 32;
	$user_auth_realm_filenames['hostReport.php'] = 32;
	$user_auth_realm_filenames['serviceReport.php'] = 32;
}

function npc_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["npc_host_id"] = array(
                		"method" => "drop_sql",
				"friendly_name" => "Nagios Host Mapping",
				"description" => "Select the Nagios host that maps to this host.",
				"value" => "|arg1:npc_host_id|",
		                "none_value" => "None",
                		"sql" => "select id,name from npc_host",
				"form_id" => false
			);
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

function npc_api_device_save ($save) {
	if (isset($_POST['npc_host_id']))
		$save["npc_host_id"] = form_input_validate($_POST['npc_host_id'], "npc_host_id", "", true, 3);
	else
		$save['npc_host_id'] = form_input_validate('', "npc_host_id", "", true, 3);
	return $save;
}

function npc_draw_navigation_text ($nav) {
   $nav["npc.php:"] = array("title" => "Summary", "mapping" => "index.php:", "url" => "npc.php", "level" => "2");
   $nav["hostList.php:"] = array("title" => "Host List", "mapping" => "npc.php:", "url" => "hostList.php", "level" => "3");
   $nav["hostReport.php:"] = array("title" => "Reporting", "mapping" => "npc.php:", "url" => "hostReport.php", "level" => "3");
   $nav["serviceReport.php:"] = array("title" => "Reporting", "mapping" => "npc.php:", "url" => "serviceReport.php", "level" => "3");
   $nav["statusDetail.php:"] = array("title" => "Status Detail", "mapping" => "npc.php:", "url" => "statusDetail.php", "level" => "3");
   $nav["extinfo.php:"] = array("title" => "Service / Host Information", "mapping" => "statusDetail.php:", "url" => "extinfo.php", "level" => "4");
   $nav["command.php:"] = array("title" => "Command Execution", "mapping" => "extinfo.php:", "url" => "command.php", "level" => "5");
   return $nav;
}

function npc_setup_table () {
        global $config, $database_default;
        include_once($config["library_path"] . "/database.php");

        $sql = "show columns from host from " . $database_default;
        $result = mysql_query($sql) or die (mysql_error());
        $found = false;
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
                if ($row['Field'] == 'npc_host_id')
                        $found = true;
        }
        if (!$found) {
                $sql = "alter table host add npc_host_id int(11) default NULL COMMENT 'reference to a Cacti host'";
                $result = mysql_query($sql) or die (mysql_error());
        }


        $sql = "show tables from " . $database_default;
        $result = db_fetch_assoc($sql) or die (mysql_error());

        $tables = array();
        $sql = array();

        foreach($result as $index => $arr) {
                foreach ($arr as $t) {
                        $tables[] = $t;
                }
        }

        if (!in_array('npc_config_params', $tables)) {
                $sql[] = "CREATE TABLE `npc_config_params` (
			  `opt` char(64) NOT NULL default '',
			  `value` int(11) default NULL,
			  PRIMARY KEY  (`opt`),
			  UNIQUE KEY `opt` (`opt`)
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Nagios configuration data';";
        }

	if (!in_array('npc_flapping_host', $tables)) {
		$sql[] = "CREATE TABLE `npc_flapping_host` (
			  `id` int(11) NOT NULL default '0',
			  PRIMARY KEY  (`id`),
			  CONSTRAINT `flapping_host_ibfk_1` FOREIGN KEY (`id`) REFERENCES `npc_host` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Flapping hosts';";
	}

	if (!in_array('npc_flapping_service', $tables)) {
		$sql[] = "CREATE TABLE `npc_flapping_service` (
			  `id` int(11) NOT NULL default '0',
			  PRIMARY KEY  (`id`),
			  CONSTRAINT `flapping_service_ibfk_1` FOREIGN KEY (`id`) REFERENCES `npc_service` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Flapping services';";
	}

	if (!in_array('npc_host', $tables)) {
		$sql[] = "CREATE TABLE `npc_host` (
			  `id` int(11) NOT NULL auto_increment COMMENT 'the unique numeric id for this host',
			  `name` varchar(64) NOT NULL default '' COMMENT 'the name of this host; how nagios keeps things unique, len from nagios MAX_HOSTNAME_LENGTH',
			  `active_checks_enabled` tinyint(1) NOT NULL default '0',
			  `passive_checks_enabled` tinyint(1) NOT NULL default '0',
			  `event_handler_enabled` tinyint(1) NOT NULL default '0',
			  `flap_detection_enabled` tinyint(1) NOT NULL default '0',
			  `notifications_enabled` tinyint(1) NOT NULL default '0',
			  `failure_prediction_enabled` tinyint(1) NOT NULL default '0',
			  `process_performance_data` tinyint(1) NOT NULL default '0',
			  `obsess_over_host` tinyint(1) NOT NULL default '0',
			  `event_handler` text COMMENT 'name of the event handler command, if any',
			  `configured` tinyint(1) NOT NULL default '0',
			  `modified_attributes` int(11) default NULL COMMENT 'a bitfield of flags',
			  `has_been_checked` tinyint(1) NOT NULL default '0' COMMENT 'not sure when this would ever be false, except perhaps for new things',
			  `should_be_scheduled` tinyint(1) NOT NULL default '0' COMMENT 'Does this just refer to the host check, or to all services on this host?',
			  `cacti_graph_id` mediumint(8),
			  `cacti_host_id` mediumint(8) unsigned,
			  PRIMARY KEY  (`id`),
			  UNIQUE KEY `name` (`name`),
			  KEY `host_name_index` (`name`)
		       	  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Host data';";
	}

	if (!in_array('npc_host_check', $tables)) {
		$sql[] = "CREATE TABLE `npc_host_check` (
			  `hostid` int(11) NOT NULL default '0',
			  `check_command` varchar(64) NOT NULL default '' COMMENT 'what command is used to check host availability; unique per host, len from nagios MAX_SERVICEDESC_LENGTH',
			  `check_execute_time` float NOT NULL default '0' COMMENT 'execute time of said command',
			  `check_latency` float NOT NULL default '0' COMMENT 'how late the check was in running',
			  `last_check` int(11) NOT NULL default '0' COMMENT 'unixtime of last check',
			  `next_check` int(11) NOT NULL default '0' COMMENT 'unixtime of next scheduled check',
			  `max_attempts` int(11) NOT NULL default '0' COMMENT 'how many times this will be tried',
			  `last_notification` int(11) NOT NULL default '0' COMMENT 'unixtime for the last notification',
			  `next_notification` int(11) NOT NULL default '0' COMMENT 'unixtime for the next notification',
			  `no_more_notifications` tinyint(1) NOT NULL default '0' COMMENT 'will more notifications be sent?',
			  `check_type` int(11) NOT NULL default '0',
			  `performance_data` text,
			  UNIQUE KEY `host_check_unique_index` (`hostid`,`check_command`),
			  KEY `host_check_hostid_index` (`hostid`),
			  CONSTRAINT `host_check_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `npc_host` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Host check data';";
	}

	if (!in_array('npc_host_history', $tables)) {
		$sql[] = "CREATE TABLE `npc_host_history` (
			  `hostid` int(11) NOT NULL default '0',
			  `started` int(11) NOT NULL default '0' COMMENT 'unixtime of when the host entered this period',
			  `lasted` int(11) default NULL COMMENT 'seconds the host remained in this period',
			  `soft_state` int(11) default NULL COMMENT 'pulled from \"current_state\"',
			  `hard_state` int(11) default NULL COMMENT 'pulled from \"last_hard_state\"',
			  `current_attempt` int(11) default NULL COMMENT 'how many times this has been tried?',
			  `plugin_output` text COMMENT 'the plugin output at the start of this period',
			  UNIQUE KEY `host_history_unique_index` (`hostid`,`soft_state`,`hard_state`,`started`),
			  KEY `host_history_lasted_index` (`lasted`),
			  CONSTRAINT `host_history_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `npc_host` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Host history';";
	}

	if (!in_array('npc_hostgroup', $tables)) {
		$sql[] = "CREATE TABLE `npc_hostgroup` (
			  `id` int(11) NOT NULL auto_increment COMMENT 'the unique numeric id for this hostgroup; known only to the db',
			  `name` varchar(64) NOT NULL default '' COMMENT 'the name of this hostgroup; how nagios keeps things unique, len from nagios MAX_HOSTNAME_LENGTH',
			  `alias` text,
			  `configured` tinyint(1) NOT NULL default '0',
			  PRIMARY KEY  (`id`),
			  UNIQUE KEY `name` (`name`),
			  KEY `index_hostgroup_name` (`name`)
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Defined hostgroups';";
	}

	if (!in_array('npc_hostgroup_membership', $tables)) {
		$sql[] = "CREATE TABLE `npc_hostgroup_membership` (
			  `hostid` int(11) NOT NULL default '0',
			  `groupid` int(11) NOT NULL default '0',
			  KEY `hostid` (`hostid`),
			  KEY `groupid` (`groupid`),
			  CONSTRAINT `hostgroup_membership_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `npc_host` (`id`) ON DELETE CASCADE,
			  CONSTRAINT `hostgroup_membership_ibfk_2` FOREIGN KEY (`groupid`) REFERENCES `npc_hostgroup` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Hostgroup membership';";
	}

	if (!in_array('npc_service', $tables)) {
		$sql[] = "CREATE TABLE `npc_service` (
			  `id` int(11) NOT NULL auto_increment COMMENT 'the unique numeric id for this service; known only to the db',
			  `hostid` int(11) NOT NULL default '0' COMMENT 'the id of the host the service is attached to',
			  `service_description` varchar(64) NOT NULL default '' COMMENT 'the description of the service; combined with the host, how nagios keeps services unique, len from nagios MAX_SERVICEDESC_LENGTH',
			  `active_checks_enabled` tinyint(1) NOT NULL default '0',
			  `passive_checks_enabled` tinyint(1) NOT NULL default '0',
			  `event_handler_enabled` tinyint(1) NOT NULL default '0',
			  `flap_detection_enabled` tinyint(1) NOT NULL default '0',
			  `notifications_enabled` tinyint(1) NOT NULL default '0',
			  `failure_prediction_enabled` tinyint(1) NOT NULL default '0',
			  `process_performance_data` tinyint(1) NOT NULL default '0',
			  `obsess_over_service` tinyint(1) NOT NULL default '0',
			  `event_handler` text COMMENT 'name of the event handler command, if any',
			  `configured` tinyint(1) NOT NULL default '0',
			  `modified_attributes` int(11) default NULL COMMENT 'a bitfield of flags',
			  `has_been_checked` tinyint(1) NOT NULL default '0' COMMENT 'not sure when this would ever be false, except perhaps for new things',
			  `should_be_scheduled` tinyint(1) NOT NULL default '0' COMMENT 'synonymous with \"is this service active\"?',
			  `cacti_graph_id` mediumint(8) unsigned default NULL,
			  PRIMARY KEY  (`id`),
			  UNIQUE KEY `service_name_index` (`hostid`,`service_description`),
			  CONSTRAINT `service_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `npc_host` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Service data';";
	}

	if (!in_array('npc_service_check', $tables)) {
		$sql[] = "CREATE TABLE `npc_service_check` (
			  `serviceid` int(11) NOT NULL default '0',
			  `check_command` varchar(64) NOT NULL default '' COMMENT 'what command is used to check host availability; unique per host, len from nagios MAX_SERVICEDESC_LENGTH',
			  `check_execute_time` float default NULL COMMENT 'execute time of said command',
			  `check_latency` float default NULL COMMENT 'how late the check was in running',
			  `last_check` int(11) default NULL COMMENT 'unixtime of last check',
			  `next_check` int(11) default NULL COMMENT 'unixtime of next scheduled check',
			  `max_attempts` int(11) default NULL COMMENT 'how many times this will be tried',
			  `last_notification` int(11) default NULL COMMENT 'unixtime for the last notification',
			  `next_notification` int(11) default NULL COMMENT 'unixtime for the next notification',
			  `no_more_notifications` tinyint(1) default NULL COMMENT 'will more notifications be sent?',
			  `check_type` int(11) NOT NULL default '0',
			  `performance_data` text,
			  UNIQUE KEY `service_check_unique_index` (`serviceid`,`check_command`),
			  KEY `service_check_serviceid_index` (`serviceid`),
			  CONSTRAINT `service_check_ibfk_1` FOREIGN KEY (`serviceid`) REFERENCES `npc_service` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Service check data';";
	}

	if (!in_array('npc_service_history', $tables)) {
		$sql[] = "CREATE TABLE `npc_service_history` (
			  `serviceid` int(11) NOT NULL default '0',
			  `started` int(11) NOT NULL default '0' COMMENT 'unixtime of when the service entered this period',
			  `lasted` int(11) default NULL COMMENT 'seconds the service remained in this period',
			  `soft_state` int(11) default NULL COMMENT 'pulled from \"current_state\"',
			  `hard_state` int(11) default NULL COMMENT 'pulled from \"last_hard_state\"',
			  `current_attempt` int(11) default NULL COMMENT 'how many times this has been tried?',
			  `plugin_output` text COMMENT 'the plugin output at the start of this period',
			  UNIQUE KEY `service_history_unique_index` (`serviceid`,`soft_state`,`hard_state`,`started`),
			  KEY `service_history_lasted_index` (`lasted`),
			  CONSTRAINT `service_history_ibfk_1` FOREIGN KEY (`serviceid`) REFERENCES `npc_service` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Service history';";
	}

	if (!in_array('npc_comment', $tables)) {
		$sql[] = "CREATE TABLE `npc_comment` (
			  `id` int(11) NOT NULL auto_increment,
			  `serviceid` int(11) NOT NULL default '0',
			  `hostid` mediumint(8) unsigned NOT NULL default '0',
			  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			  `author` varchar(64) NOT NULL default '' COMMENT 'comment author',
			  `comment` text COMMENT 'the service comment',
			  `persist` tinyint(1) NOT NULL default '0',
			  `type` tinyint(1) NOT NULL default '0' COMMENT '1 = host comment, 2 = service comment, 3 = host acknowledgment, 4 = service acknowledgment',
			  PRIMARY KEY  (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Service Comments';";
	}

	if (!in_array('npc_downtime', $tables)) {
		$sql[] = "CREATE TABLE `npc_downtime` (
			  `id` int(11) NOT NULL auto_increment,
			  `type` tinyint(1) NOT NULL COMMENT '1 = host downtime, 2 = service downtime',
			  `serviceid` int(11) NOT NULL default '0',
			  `hostid` mediumint(8) unsigned NOT NULL default '0',
			  `entry` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			  `start` int(11) NOT NULL COMMENT 'unixtime of when the downtime starts',
			  `end` int(11) NOT NULL COMMENT 'unixtime of when the downtime ends',
			  `duration` mediumint(8) unsigned NOT NULL,
			  `author` varchar(64) NOT NULL COMMENT 'comment author',
			  `comment` text COMMENT 'the downtime comment',
			  `commentid` int(11) NOT NULL COMMENT 'The commentid from npc_comment referring to this downtime event',
			  `fixed` tinyint(1) NOT NULL default '0',
			  `trigger` mediumint(8) unsigned NOT NULL default '0' COMMENT 'reference to a previously scheduled downtime';,
			  PRIMARY KEY  (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Scheduled downtime';";
	}

	if (!in_array('npc_servicegroup', $tables)) {
		$sql[] = "CREATE TABLE `npc_servicegroup` (
			  `id` int(11) NOT NULL auto_increment COMMENT 'the unique numeric id for this servicegroup; known only to the db',
			  `name` varchar(64) NOT NULL default '' COMMENT 'the name of thie servicegroup; how nagios keeps things unique, len from nagios MAX_HOSTNAME_LENGTH',
			  `alias` text,
			  `configured` tinyint(1) NOT NULL default '0',
			  PRIMARY KEY  (`id`),
			  UNIQUE KEY `name` (`name`),
			  KEY `index_servicegroup_name` (`name`)
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Defined servicegroups';";
	}

	if (!in_array('npc_servicegroup_membership', $tables)) {
		$sql[] = "CREATE TABLE `npc_servicegroup_membership` (
			  `serviceid` int(11) NOT NULL default '0',
			  `groupid` int(11) NOT NULL default '0',
			  KEY `serviceid` (`serviceid`),
			  KEY `groupid` (`groupid`),
			  CONSTRAINT `servicegroup_membership_ibfk_1` FOREIGN KEY (`serviceid`) REFERENCES `npc_service` (`id`) ON DELETE CASCADE,
			  CONSTRAINT `servicegroup_membership_ibfk_2` FOREIGN KEY (`groupid`) REFERENCES `npc_servicegroup` (`id`) ON DELETE CASCADE
			  ) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Defined hostgroups';";
	}



        if (!empty($sql)) {
                for ($a = 0; $a < count($sql); $a++) {
                        $result = mysql_query($sql[$a]);
                }
        }

}

function npc_version () {
	return array( 'name' 	=> 'npc',
		      'version' => '0.1');
}

?>
