<?php
/*
 +-------------------------------------------------------------------------+
 | Nagios Plugin 0.1a for Cacti 0.8.6f                                     |
 | Copyright (C) 2005 Billy Gunn (billy@gunn.org)                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti and Nagios are the copyright of their respective owners.          |
 +-------------------------------------------------------------------------+
*/

chdir('../../');
include_once("./include/auth.php");
include_once("./include/config.php");

// Refresh the page at a user supplied interval
header("Refresh: " . read_config_option("npc_refresh") . "; URL=" . $_SERVER["REQUEST_URI"]);
include("top_npc_header.php");



function formatTime($time) {

        $days = floor($time/60/60/24);
        $time -= $days*60*60*24;
        $hours = floor($time/60/60);
        $time -= $hours*60*60;
        $minutes = floor($time/60);
        $time -= $minutes*60;
        $seconds = $time;

        return ($days . "d " . $hours . "h " . $minutes . "m " . $seconds . "s");
}

if (!isset($_REQUEST["filter"])) { $_REQUEST["filter"] = ""; }
switch ($_REQUEST["filter"]) {
        case 'serviceProblems':
		$whereClause = "where service_soft_state != 0 and service_soft_state != -1";
                break;

        case 'showHost':
		$whereClause = "where name like '%" . $_REQUEST["name"] . "%'";
                break;

        default:
		$whereClause = "";
                break;
}

	$service_detail = db_fetch_assoc("
select distinct
        hostid,
        name,
        host_soft_state,
        host_notifications,
        service,
	serviceid,
        service_soft_state,
        service_notifications,
	svc_active_checks,
	svc_passive_checks,
        service_graph,
        host_graph,
	host_active_checks,
	host_passive_checks,
        last_check,
        next_check,
        duration,
        current_attempt,
        max_attempts,
        plugin_output
from
        (
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        npc_hostgroup_membership.groupid as hostgroup,
                        npc_host_history.soft_state as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        npc_service_history.soft_state as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        unix_timestamp() - npc_service_history.started as duration,
                        npc_service_history.current_attempt,
                        npc_service_check.max_attempts,
                        npc_service_history.plugin_output
                from
                        npc_host,
                        npc_host_history,
                        npc_hostgroup_membership,
                        npc_service,
                        npc_service_check,
                        npc_service_history
                where
                        npc_host.id = npc_hostgroup_membership.hostid and
                        npc_host.id = npc_service.hostid and
                        npc_host.id = npc_host_history.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_service.id = npc_service_history.serviceid and
                        npc_service_history.lasted is null and
                        npc_host_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = TRUE and
                        npc_host.has_been_checked = TRUE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        0 as hostgroup,
                        npc_host_history.soft_state as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        npc_service_history.soft_state as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        unix_timestamp() - npc_service_history.started as duration,
                        npc_service_history.current_attempt,
                        npc_service_check.max_attempts,
                        npc_service_history.plugin_output
                from
                        npc_host,
                        npc_host_history,
                        npc_service,
                        npc_service_check,
                        npc_service_history
                where
                        npc_host.id not in (select hostid from npc_hostgroup_membership) and
                        npc_host.id = npc_service.hostid and
                        npc_host.id = npc_host_history.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_service.id = npc_service_history.serviceid and
                        npc_service_history.lasted is null and
                        npc_host_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = TRUE and
                        npc_host.has_been_checked = TRUE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        npc_hostgroup_membership.groupid as hostgroup,
                        -1 as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        npc_service_history.soft_state as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        unix_timestamp() - npc_service_history.started as duration,
                        npc_service_history.current_attempt,
                        npc_service_check.max_attempts,
                        npc_service_history.plugin_output
                from
                        npc_host,
                        npc_hostgroup_membership,
                        npc_service,
                        npc_service_check,
                        npc_service_history
                where
                        npc_host.id = npc_hostgroup_membership.hostid and
                        npc_host.id = npc_service.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_service.id = npc_service_history.serviceid and
                        npc_service_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = TRUE and
                        npc_host.has_been_checked = FALSE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        0 as hostgroup,
                        -1 as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        npc_service_history.soft_state as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        unix_timestamp() - npc_service_history.started as duration,
                        npc_service_history.current_attempt,
                        npc_service_check.max_attempts,
                        npc_service_history.plugin_output
                from
                        npc_host,
                        npc_service,
                        npc_service_check,
                        npc_service_history
                where
                        npc_host.id not in (select hostid from npc_hostgroup_membership) and
                        npc_host.id = npc_service.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_service.id = npc_service_history.serviceid and
                        npc_service_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = TRUE and
                        npc_host.has_been_checked = FALSE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        npc_hostgroup_membership.groupid as hostgroup,
                        npc_host_history.soft_state as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        -1 as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        0 as duration,
                        0 as current_attempt,
                        npc_service_check.max_attempts,
                        null as plugin_output
                from
                        npc_host,
                        npc_host_history,
                        npc_hostgroup_membership,
                        npc_service,
                        npc_service_check
                where
                        npc_host.id = npc_hostgroup_membership.hostid and
                        npc_host.id = npc_service.hostid and
                        npc_host.id = npc_host_history.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_host_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = FALSE and
                        npc_host.has_been_checked = TRUE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        0 as hostgroup,
                        npc_host_history.soft_state as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        -1 as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        0 as duration,
                        0 as current_attempt,
                        npc_service_check.max_attempts,
                        null as plugin_output
                from
                        npc_host,
                        npc_host_history,
                        npc_service,
                        npc_service_check
                where
                        npc_host.id not in (select hostid from npc_hostgroup_membership) and
                        npc_host.id = npc_service.hostid and
                        npc_host.id = npc_host_history.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_host_history.lasted is null and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = FALSE and
                        npc_host.has_been_checked = TRUE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        npc_hostgroup_membership.groupid as hostgroup,
                        -1 as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        -1 as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        0 as duration,
                        0 as current_attempt,
                        npc_service_check.max_attempts,
                        null as plugin_output
                from
                        npc_host,
                        npc_hostgroup_membership,
                        npc_service,
                        npc_service_check
                where
                        npc_host.id = npc_hostgroup_membership.hostid and
                        npc_host.id = npc_service.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = FALSE and
                        npc_host.has_been_checked = FALSE
                union
                select
                        npc_host.id as hostid,
                        npc_host.name,
                        0 as hostgroup,
                        -1 as host_soft_state,
                        npc_host.notifications_enabled as host_notifications,
                        npc_host.active_checks_enabled as host_active_checks,
                        npc_host.passive_checks_enabled as host_passive_checks,
                        npc_host.cacti_graph_id as host_graph,
                        npc_service.id as serviceid,
                        npc_service.cacti_graph_id as service_graph,
                        npc_service.service_description as service,
                        -1 as service_soft_state,
                        npc_service.notifications_enabled as service_notifications,
                        npc_service.active_checks_enabled as svc_active_checks,
                        npc_service.passive_checks_enabled as svc_passive_checks,
                        npc_service_check.last_check,
                        npc_service_check.next_check,
                        0 as duration,
                        0 as current_attempt,
                        npc_service_check.max_attempts,
                        null as plugin_output
                from
                        npc_host,
                        npc_service,
                        npc_service_check
                where
                        npc_host.id not in (select hostid from npc_hostgroup_membership) and
                        npc_host.id = npc_service.hostid and
                        npc_service.id = npc_service_check.serviceid and
                        npc_service.configured = TRUE and
                        npc_service.has_been_checked = FALSE and
                        npc_host.has_been_checked = FALSE
                order by
                        name
        ) as host_details $whereClause");


	$row_count = count($service_detail);




?>

   <table width="98%" border="0" align="center">
      <tr class="textHeaderDark" bgcolor='#00438C'>
         <td align="center"><strong>Status Detail</strong></td>
      </tr>
      <tr>
         <td width="40%" valign="top">
            <table width="100%" align="center" cellpadding="3">
            <thead>
               <tr class="textSubHeaderDark" bgcolor='#6d88ad'>
               <td nowrap><a class='noLink' href="#" onclick="return toggleAll('expand')">+</a> / <a class='noLink' href="#" onclick="return toggleAll('collapse')">-</a></td>
               <td>Host</td>
               <td>Service</td>
               <td>Status</td>
               <td>Last Check</td>
               <td>Next Check</td>
               <td>Duration</td>
               <td>Attempt</td>
               <td>Plugin Output</td>
      </tr>
      </thead>

<?php

	$background1 = "#F5F5F5";
	$background2 = "#E7E9F2";
	$rowColor = $background1;

	$last_host = 0;

        for($i = 0; $i < $row_count; $i++) {

		$wrote_host = 0;
		$draw_host_graph = 0;

		if($last_host != $service_detail[$i]["hostid"]) {
			if ($i > 0) {
				echo "</tbody>";
			}
		}


                echo "<tr>\n";

		/* Here we loop through each row based on the name of the host from the outer loop. 
		   The purpose is to find the overall status and set the appropriate colored gif 
		   in the Status cell which will act as a button to show/hide additional rows */
		if($last_host != $service_detail[$i]["hostid"]) {
			$overallStatus = -100;
			for($x = 0; $x < $row_count; $x++) {
			  	if ($service_detail[$i]["name"] == $service_detail[$x]["name"]) {
       					if ($service_detail[$x]["host_soft_state"] == 0 && $service_detail[$x]["service_soft_state"] == 0 && $overallStatus < 0) {
						$overallStatus = 0;
					} 
					if ($service_detail[$x]["service_soft_state"] == -1 && $overallStatus < 1) {
						$overallStatus = 1;
					} 
					if ($service_detail[$x]["service_soft_state"] == 3 && $overallStatus < 2) {
						$overallStatus = 2;
					} 
					if ($service_detail[$x]["service_soft_state"] == 1 && $overallStatus < 3) {
						$overallStatus = 3;
					} 
					if ($service_detail[$x]["host_soft_state"] == 1 || $service_detail[$x]["service_soft_state"] == 2 && $overallStatus < 4) {
						$overallStatus = 4;
					}
				}
			}

	                switch($overallStatus) {
                        	case "0":
			    		echo "<td align='center' bgcolor='" . $rowColor . "'><a onclick=\"toggleItem('" . $i . "'); return false;\">";
				    	echo "<img src='images/dot_green.gif' alt='green' title='Display all services' border='0'></a></td>";
                                	break;
                        	case "1":
			    		echo "<td align='center' bgcolor='" . $rowColor . "'><a onclick=\"toggleItem('" . $i . "'); return false;\">";
			    		echo "<img src='images/dot_blue.gif' alt='blue' title='Display all services' border='0'></a></td>";
                                	break;
                        	case "2":
			    		echo "<td align='center' bgcolor='" . $rowColor . "'><a onclick=\"toggleItem('" . $i . "'); return false;\">";
			    		echo "<img src='images/dot_orange.gif' alt='orange' title='Display all services' border='0'></a></td>";
                                	break;
                        	case "3":
			    		echo "<td align='center' bgcolor='" . $rowColor . "'><a onclick=\"toggleItem('" . $i . "'); return false;\">";
			    		echo "<img src='images/dot_yellow.gif' alt='yellow' title='Display all services' border='0'></a></td>";
                                	break;
                        	case "4":
			    		echo "<td align='center' bgcolor='" . $rowColor . "'><a onclick=\"toggleItem('" . $i . "'); return false;\">";
			    		echo "<img src='images/dot_red.gif' alt='red' title='Display all services' border='0'></a></td>";
                                	break;
                	}
		} else {
		   echo "<td bgcolor='" . $rowColor . "' nowrap></td>";
		}

		echo "<td";

		if ($last_host != $service_detail[$i]["hostid"]) {

			/* Display the host cell with color coding based on the host status*/
			switch($service_detail[$i]["host_soft_state"])
               		{
	                        case "1":
       		                        echo " class='statusHOSTDOWN' nowrap>";
               		                break;
                       		case "2":
                               		echo " class='statusHOSTUNREACHABLE' nowrap>";
	                                break;
				default:
					echo " bgcolor='" . $rowColor . "' nowrap>";
					break;
        	       	}

			if ($service_detail[$i]["host_graph"]) {
				echo "<a onclick=\"toggleItem('hostGraph" . $i . "'); return false;\"><img src='images/graph.gif' alt='graph' border='0'></a> ";
				$draw_host_graph = 1;
			}

                        $last_host = $service_detail[$i]["hostid"];

			/* Create the links to the host info for each host */
			echo "<a href='extinfo.php?type=1&hostid=" . $service_detail[$i]["hostid"] . "&hostname=" . $service_detail[$i]["name"] . "'>" . $service_detail[$i]["name"] . "</a>";

			/* Add the appropriate icons based on service configuration*/
			$host_comment = db_fetch_cell("select count(*) as comments from npc_comment where hostid = " . $service_detail[$i]["hostid"] . ";");
			$host_ack = db_fetch_cell("select type from npc_comment where hostid = " . $service_detail[$i]["hostid"] . " and type = 3;");
                	if ($host_comment["comments"]) {
                        	echo "&nbsp <IMG SRC='images/comment.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='There are comments for this host' TITLE='This host has " . $host_comment["comments"] . " comments'>";
                	}
			if ($host_ack["type"]) {
				echo "&nbsp; <IMG SRC='images/ack.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='This host problem has been acknowledged' TITLE='This host problem has been acknowledged'>";
			}
			if (!$service_detail[$i]["host_active_checks"] && !$service_detail[$i]["host_passive_checks"]) {
				echo "&nbsp; <IMG SRC='images/disabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Active and passive checks have been disabled' TITLE='Active and passive checks have been disabled'>";
			} elseif (!$service_detail[$i]["host_active_checks"]) {
				echo "&nbsp <IMG SRC='images/passiveonly.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Active checks have been disabled - only passive checks are being accepted' TITLE='Active checks have been disabled - only passive checks are being accepted'>";
			}
                        if ($service_detail[$i]["host_notifications"] == "0") {
                                echo " <IMG SRC='images/ndisabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Notifications disabled' TITLE='Notifications disabled'>\n";
                        }
			

			$wrote_host = 1;

		} else {
			echo " bgcolor='" . $rowColor . "' nowrap>";
		}

                echo "</td>";
		echo "<td bgcolor='" . $rowColor . "' nowrap>";

		/* If a service has an associated graph, add a small graph icon in front of the service 
		   name which can be toggled to show/hide the graph */
		if ($service_detail[$i]["service_graph"]) {
			echo "<a onclick=\"toggleItem('serviceGraph" . $i . "'); return false;\"><img src='images/graph.gif' alt='graph' border='0'></a> ";
		}

		/* Create the links to the serviceInfo for each service */
		$serviceURL = ereg_replace(" +", "+", $service_detail[$i]["service"]);
                echo "<a href='extinfo.php?type=2&hostid=" . $service_detail[$i]["hostid"] . "&hostname=" . $service_detail[$i]["name"] . "&serviceid=" . $service_detail[$i]["serviceid"] . "&service=" . $serviceURL . "'>" . $service_detail[$i]["service"] . "</a>";

		/* Add the appropriate icons based on service configuration*/
		$service_comment = db_fetch_cell("select count(*) as comments from npc_comment where serviceid = " . $service_detail[$i]["serviceid"] . ";");
		$service_ack = db_fetch_cell("select type from npc_comment where serviceid = " . $service_detail[$i]["serviceid"] . " and type = 4;");
                if ($service_comment["comments"]) {
                        echo "&nbsp <IMG SRC='images/comment.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='There are comments for this service' TITLE='This service has " . $service_comment["comments"] . " comments'>";
                }
		if ($service_ack["type"]) {
			echo "&nbsp; <IMG SRC='images/ack.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='This service problem has been acknowledged' TITLE='This service problem has been acknowledged'>";
		}
		if (!$service_detail[$i]["svc_active_checks"] && !$service_detail[$i]["svc_passive_checks"]) {
			echo "&nbsp; <IMG SRC='images/disabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Active and passive checks have been disabled' TITLE='Active and passive checks have been disabled'>";
		} elseif (!$service_detail[$i]["svc_active_checks"]) {
			echo "&nbsp <IMG SRC='images/passiveonly.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Active checks have been disabled - only passive checks are being accepted' TITLE='Active checks have been disabled - only passive checks are being accepted'>";
		}
                if (!$service_detail[$i]["service_notifications"]) {
                        echo "&nbsp <IMG SRC='images/ndisabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Notifications for this service have been disabled' TITLE='Notifications for this service have been disabled'>";
                }
		$flapping = db_fetch_cell("select id from npc_flapping_service where id = " . $service_detail[$i]["serviceid"]);
                if ($flapping["id"]) {
       		         echo " <IMG SRC='images/flapping.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Flapping' TITLE='This service is flapping between states'>\n";
                }
		
		echo "</td>";

                /* Display the service status with the appropriate color coding */
                switch($service_detail[$i]["service_soft_state"])
                {
                        case "-1":
                                echo "<td class='statusPENDING'>PENDING</td>";
                                break;
                        case "0":
                                echo "<td class='statusOK'>OK</td>";
                                break;
                        case "1":
                                echo "<td class='statusWARNING'>WARNING</td>";
                                break;
                        case "2":
                                echo "<td class='statusCRITICAL'>CRITICAL</td>";
                                break;
                        case "3":
                                echo "<td class='statusUNKNOWN'>UNKNOWN</td>";
                                break;
                }


		echo "<td bgcolor='" . $rowColor . "' nowrap>";

		if ($service_detail[$i]["last_check"] == 0) {
			echo "N/A</td><td bgcolor=\"" . $rowColor;
		} else {
                	echo date("Y-m-d H:i:s",$service_detail[$i]["last_check"]) . "</td><td bgcolor=\"" . $rowColor;
		}

                echo "\" nowrap>" . date("Y-m-d H:i:s",$service_detail[$i]["next_check"]) . "</td><td bgcolor=\"" . $rowColor . "\" nowrap>";
                echo formatTime($service_detail[$i]["duration"]) . "</td><td bgcolor=\"" . $rowColor . "\">" . $service_detail[$i]["current_attempt"];
                echo "/" . $service_detail[$i]["max_attempts"] . "</td>";

		if ($service_detail[$i]["plugin_output"] == "") {
			echo "<td bgcolor='" . $rowColor . "'>Service check scheduled for " . date("Y-m-d H:i:s",$service_detail[$i]["next_check"]);
		} else {
			echo "<td bgcolor=\"" . $rowColor . "\">" . $service_detail[$i]["plugin_output"];
		}

                echo "</td></tr>";

		/* If a host has an associated graph, build a table to hold the graph */
		if ($service_detail[$i]["host_graph"] && $draw_host_graph) {
			echo "<tr><td colspan='8'>";
			echo "<center><table>";
			echo "<tbody id='hostGraph" . $i . "' style='display:none';>";
			echo "<tr><td>";
			echo "<img src='../../graph_image.php?local_graph_id=" . $service_detail[$i]["host_graph"] . "&rra_id=0'>";
			echo "</td></tr>";
			echo "</tbody>";
			echo "</table></center>";
			echo "</td></tr>";
		}

		/* If a service has an associated graph, build a table to hold the graph */
		if ($service_detail[$i]["service_graph"]) {
			echo "<tr><td colspan='8'>";
			echo "<table>";
			echo "<tbody id='serviceGraph" . $i . "' style='display:none';>";
			echo "<tr><td>";
			echo "<img src='../../graph_image.php?local_graph_id=" . $service_detail[$i]["service_graph"] . "&rra_id=0'>";
			echo "</td></tr>";
			echo "</tbody>";
			echo "</table>";
			echo "</td></tr>";
		}


		if($wrote_host) {
			echo "<tbody class='collapse_obj' id='$i'";
			if (!isset($_REQUEST["filter"])) { 
				echo " style='display: none'";
			}
			echo ">";
		}


		/* Alternate the row colors */
                if($rowColor == $background1) {
                        $rowColor = $background2;
                } else {
                        $rowColor = $background1;
                }


        }

   echo "</table>";
echo "</td>";
echo "</tr>";
echo "</table>";

	include("./include/bottom_footer.php");
?>

